local function WLHUD_Chain( object )
	
	-- Setup the metatable
	local T = {}
	setmetatable( T, { __index = function( self, func )
		
		-- Know when to stop chaining
		if func == "__END" then	return object end
		
		-- Otherwise, add the method to the parent object
		return function( self, ... )
			assert( object[func], func .. " missing in object" )
			object[func]( object, ... )
			return self
		end
	end })
	
	-- Return the metatable
	return T
end

function WLHUD_MEM_USAGE:Create()
	WLHUD_MEM_USAGE.Anchor = WLHUD_Chain(WINDOW_MANAGER:CreateTopLevelWindow("WLHUD_MEM_USAGE.Anchor"))
		:SetAnchor(TOPLEFT, GuiRoot, TOPLEFT, 5,5)
		:SetDimensions(275, 25)
		:SetHidden(true)
	.__END

	WLHUD_MEM_USAGE.BG = WLHUD_Chain(WINDOW_MANAGER:CreateControl("WLHUD_MEM_USAGE.BG", WLHUD_MEM_USAGE.Anchor, CT_BACKDROP))
		:SetCenterColor(0.13,0.13,0.13,0.5)
		:SetEdgeColor(0.85, 0.85, 0.85,1)
		:SetEdgeTexture("", 8, 1, 1)
		:SetDrawLayer(1)
		:SetAnchor(TOPLEFT, GuiRoot, TOPLEFT, 5,5)
		:SetDimensions(275, 25)
		:SetHidden(true)
	.__END
	
	WLHUD_MEM_USAGE.LBL = WLHUD_Chain(WINDOW_MANAGER:CreateControl("WLHUD_MEM_USAGE.LBL", WLHUD_MEM_USAGE.Anchor, CT_LABEL ))
		:SetFont("ZoFontBossName")
		:SetDrawLayer(4)
		:SetText(WLHUD_MemUsage_Text)
		:SetAnchor(CENTER, WLHUD_MEM_USAGE.BG, CENTER, 0,0)
		:SetHidden(true)
	.__END
end --WLHUD_Create_MemUsage()