local function WLHUD_Chain( object )
	
	-- Setup the metatable
	local T = {}
	setmetatable( T, { __index = function( self, func )
		
		-- Know when to stop chaining
		if func == "__END" then	return object end
		
		-- Otherwise, add the method to the parent object
		return function( self, ... )
			assert( object[func], func .. " missing in object" )
			object[func]( object, ... )
			return self
		end
	end })
	
	-- Return the metatable
	return T
end

function WLHUD_MESSAGE:Create()
	-- local WLHUD_Execute_Tex = "WarLegendHUD/img/exec/tex_exec_2.dds"
	local WLHUD_Anchor_Tex = "WarLegendHUD/img/anchor.dds"

	WLHUD_MESSAGE_MW = WLHUD_Chain(WINDOW_MANAGER:CreateControl("WLHUD_MESSAGE", WLHUD_PLAYER.Anchor, CT_BACKDROP))
		:SetCenterColor(0.8, 0.8, 0.8,0.25)
		:SetEdgeColor(1, 1, 1,1)
		:SetEdgeTexture("", 8, 1, 1)
		:SetDrawLayer(1)
		:SetDimensions(200,44)
		:SetAnchor(TOPLEFT, GuiRoot, TOPLEFT, WLHUD_SAVE.Global_X + WLHUD_SAVE.SharedArea_X,WLHUD_SAVE.Global_Y + WLHUD_SAVE.SharedArea_Y)
		:SetHidden(true)
	.__END

	WLHUD_MESSAGE.Anchor = WLHUD_Chain(WINDOW_MANAGER:CreateControl("WLHUD_MESSAGE.Anchor", WLHUD_MESSAGE_MW, CT_TEXTURE ))
		:SetDimensions(25,25)
		:SetTexture(WLHUD_Anchor_Tex)
		:SetDrawLayer(4)
		:SetAnchor(TOPLEFT, WLHUD_MESSAGE_MW, TOPLEFT, 5,5)
		-- :SetHidden(true)
	.__END
	
	WLHUD_MESSAGE.LBL = WLHUD_Chain(WINDOW_MANAGER:CreateControl("WLHUD_MESSAGE.LBL", WLHUD_PLAYER.Anchor, CT_LABEL ))
		:SetColor(0.8, 0.8, 0.8, 1)
		:SetFont(WLHUD_SAVE.Bars_Font)
		:SetDrawLayer(4)
		:SetText(WLHUD_MESSAGE.Text)
		:SetAnchor(CENTER, WLHUD_MESSAGE_MW, CENTER, 0,0)
		-- :SetHidden(true)
	.__END

	--[[#############################################################################################################]]--
	--[[ PLAYERALERTS ]]--
	--[[#############################################################################################################]]--
	WLHUD_PlayerAlert_Anchor = WLHUD_Chain(WINDOW_MANAGER:CreateTopLevelWindow("WLHUD_PlayerAlert_Anchor"))
		:SetAnchor(CENTER, WLHUD_MESSAGE_MW, CENTER, 0,50)
		:SetDimensions(200, 44)
	.__END

	WLHUD_PLAYER.LowHP_Icon = WLHUD_Chain(WINDOW_MANAGER:CreateControl("WLHUD_PLAYER.LowHP_Icon", WLHUD_PlayerAlert_Anchor, CT_TEXTURE ))
		:SetDimensions(128,128)
		:SetTexture("/esoui/art/quickslots/quickslot_highlight_blob.dds")
		:SetColor(1, 0.2, 0.2, 1)
		:SetDrawLayer(1)
		:SetAnchor(CENTER, WLHUD_PlayerAlert_Anchor, CENTER, 0,50)
		:SetHidden(true)
	.__END

	WLHUD_PLAYER.LowHP_LBL = WLHUD_Chain(WINDOW_MANAGER:CreateControl("WLHUD_PLAYER.LowHP_LBL", WLHUD_PLAYER.LowHP_Icon, CT_LABEL ))
		:SetFont("ZoFontAnnounce")
		:SetDrawLayer(4)
		:SetAnchor(CENTER, WLHUD_PlayerAlert_Anchor, CENTER, 0,50)
		:SetText(WLHUD_PLAYER.LHP_Trad)
	.__END

	WLHUD_PLAYER.LowMP_Icon = WLHUD_Chain(WINDOW_MANAGER:CreateControl("WLHUD_PLAYER.LowMP_Icon", WLHUD_PlayerAlert_Anchor, CT_TEXTURE ))
		:SetDimensions(128,128)
		:SetTexture("/esoui/art/quickslots/quickslot_highlight_blob.dds")
		:SetColor(0.2, 0.2, 1, 1)
		:SetDrawLayer(1)
		:SetAnchor(LEFT, WLHUD_PlayerAlert_Anchor, LEFT, -125,50)
		:SetHidden(true)
	.__END

	WLHUD_PLAYER.LowMP_LBL = WLHUD_Chain(WINDOW_MANAGER:CreateControl("WLHUD_PLAYER.LowMP_LBL", WLHUD_PLAYER.LowMP_Icon, CT_LABEL ))
		:SetFont("ZoFontAnnounce")
		:SetDrawLayer(4)
		:SetAnchor(LEFT, WLHUD_PlayerAlert_Anchor, LEFT, -100,50)
		:SetText(WLHUD_PLAYER.LMP_Trad)
	.__END

	WLHUD_PLAYER.LowSP_Icon = WLHUD_Chain(WINDOW_MANAGER:CreateControl("WLHUD_PLAYER.LowSP_Icon", WLHUD_PlayerAlert_Anchor, CT_TEXTURE ))
		:SetDimensions(128,128)
		:SetTexture("/esoui/art/quickslots/quickslot_highlight_blob.dds")
		:SetColor(0.2, 1, 0.2, 1)
		:SetDrawLayer(1)
		:SetAnchor(RIGHT, WLHUD_PLAYER.LowSP_BG, RIGHT, 125,50)
		:SetHidden(true)
	.__END
	
	WLHUD_PLAYER.LowSP_LBL = WLHUD_Chain(WINDOW_MANAGER:CreateControl("WLHUD_PLAYER.LowSP_LBL", WLHUD_PLAYER.LowSP_Icon, CT_LABEL ))
		:SetFont("ZoFontAnnounce")
		:SetDrawLayer(4)
		:SetAnchor(RIGHT, WLHUD_PlayerAlert_Anchor, RIGHT, 100,50)
		:SetText(WLHUD_PLAYER.LSP_Trad)
	.__END

	--[[#############################################################################################################]]--
	--[[ EXECUTE ]]--
	--[[#############################################################################################################]]--
	WLHUD_TARGET.Execute_LBL = WLHUD_Chain(WINDOW_MANAGER:CreateControl("WLHUD_TARGET.Execute_LBL", WLHUD_TARGET.Anchor, CT_LABEL ))
		:SetFont("ZoFontAnnounce")
		:SetDrawLayer(4)
		:SetAnchor(TOP, WLHUD_MESSAGE_MW, TOP, 0,220)
		:SetText("|cB22222EXECUTE")
	.__END

	WLHUD_TARGET.Execute = WLHUD_Chain(WINDOW_MANAGER:CreateControl("WLHUD_TARGET.Execute", WLHUD_TARGET.Execute_LBL, CT_TEXTURE ))
		:SetTexture("WarLegendHUD/img/exec/tex_exec_"..WLHUD_SAVE.Exec_Type..".dds")
		:SetDrawLayer(4)
		:SetDimensions(WLHUD_SAVE.Exec_Size,WLHUD_SAVE.Exec_Size)
		:SetAnchor(CENTER, WLHUD_TARGET.Execute_LBL, CENTER, 0,25 + (WLHUD_SAVE.Exec_Size / 2))
	.__END
end --WLHUD_MESSAGE:Create()