local function WLHUD_Chain( object )
	
	-- Setup the metatable
	local T = {}
	setmetatable( T, { __index = function( self, func )
		
		-- Know when to stop chaining
		if func == "__END" then	return object end
		
		-- Otherwise, add the method to the parent object
		return function( self, ... )
			assert( object[func], func .. " missing in object" )
			object[func]( object, ... )
			return self
		end
	end })
	
	-- Return the metatable
	return T
end

function WLHUD_PLAYER:Create()
	local WLHUD_PBars_Tex = "WarLegendHUD/img/tex_pbar_1.dds"
	local WLHUD_Anchor_Tex = "WarLegendHUD/img/anchor.dds"

	WLHUD_PLAYER.Anchor = WLHUD_Chain(WINDOW_MANAGER:CreateTopLevelWindow("WLHUD_PLAYER.Anchor"))
		:SetDimensions(450,50)
		:SetAnchor(TOPLEFT, GuiRoot, TOPLEFT, WLHUD_SAVE.Player_Anchor_X,WLHUD_SAVE.Player_Anchor_Y)
		:SetScale(WLHUD_SAVE.Player_Scale)
	.__END

	-- WLHUD_PLAYER.Sticky_Anchor = WLHUD_Chain(WINDOW_MANAGER:CreateControl("WLHUD_PLAYER.Sticky_Anchor", WLHUD_PLAYER.Anchor, CT_TEXTURE ))
	-- 	:SetDimensions(40,40)
	-- 	:SetTexture(WLHUD_Anchor_Tex)
	-- 	:SetDrawLayer(4)
	-- 	:SetAnchor(TOPLEFT, GuiRoot, TOPLEFT, WLHUD_SAVE.Global_X + WLHUD_SAVE.PlayerHP_Anchor_X,WLHUD_SAVE.Global_Y + WLHUD_SAVE.PlayerHP_Anchor_Y)
	-- 	-- :SetHidden(true)
	-- .__END
	
	--[[#############################################################################################################]]--
	--[[ HEALTH ]]--
	--[[#############################################################################################################]]--
	WLHUD_PLAYER.HP_Anchor = WLHUD_Chain(WINDOW_MANAGER:CreateControl("WLHUD_PLAYER.HP_Anchor", WLHUD_PLAYER.Anchor, CT_TEXTURE ))
		:SetDimensions(25,25)
		:SetTexture(WLHUD_Anchor_Tex)
		:SetDrawLayer(4)
		:SetAnchor(TOPLEFT, GuiRoot, TOPLEFT, WLHUD_SAVE.Global_X + WLHUD_SAVE.PlayerHP_Anchor_X,WLHUD_SAVE.Global_Y + WLHUD_SAVE.PlayerHP_Anchor_Y)
		:SetHidden(true)
	.__END

	WLHUD_PLAYER.HPB = WLHUD_Chain(WINDOW_MANAGER:CreateControl("WLHUD_PLAYER.HPB", WLHUD_PLAYER.Anchor, CT_STATUSBAR))
		:SetColor(0.6,0.1,0.1,0.65)
		:SetDrawLayer(2)
		:SetDimensions(WLHUD_SAVE.Player_HPBar_Width,20 + WLHUD_SAVE.PlayerHP_Height)
		:SetAnchor(LEFT, WLHUD_PLAYER.HP_Anchor, LEFT, 152,0)
	.__END
	
	WLHUD_PLAYER.HPB_BG = WLHUD_Chain(WINDOW_MANAGER:CreateControl("WLHUD_PLAYER.HPB_BG", WLHUD_PLAYER.HPB, CT_TEXTURE ))
		:SetDimensions(WLHUD_SAVE.Player_HPBar_Width + 140,55)
		:SetTexture("/esoui/art/miscellaneous/singlelinesection_left.dds")
		:SetDrawLayer(1)
		:SetAnchor(LEFT, WLHUD_PLAYER.HP_Anchor, LEFT, 12,12)
		:SetHidden(not WLHUD_SAVE.Player_HP_Enable)
	.__END
	
	WLHUD_PLAYER.HPBT = WLHUD_Chain(WINDOW_MANAGER:CreateControl("WLHUD_PLAYER.HPBT", WLHUD_PLAYER.HPB, CT_LABEL ))
		:SetFont(WLHUD_SAVE.Bars_Font)
		:SetDrawLayer(4)
		:SetText(WLHUD_PLAYER.HPText)
		:SetAnchor(LEFT, WLHUD_PLAYER.HP_Anchor, LEFT, 60,0)
		:SetScale(WLHUD_SAVE.Bars_Font_Size)
		:SetHidden(not WLHUD_SAVE.Player_HP_Enable)
	.__END
	
	WLHUD_PLAYER.HPPerc = WLHUD_Chain(WINDOW_MANAGER:CreateControl("WLHUD_PLAYER.HPPerc", WLHUD_PLAYER.HPB, CT_LABEL ))
		:SetFont(WLHUD_SAVE.Bars_Font)
		:SetDrawLayer(4)
		:SetText("100 %")
		:SetAnchor(LEFT, WLHUD_PLAYER.HP_Anchor, LEFT, (WLHUD_SAVE.Player_HPBar_Width / 450) * WLHUD_SAVE.Player_HPPerc_X + 152,0)
		:SetScale(WLHUD_SAVE.Bars_Font_Size)
	.__END

	WLHUD_PLAYER.HPB_Tex = WLHUD_Chain(WINDOW_MANAGER:CreateControl("WLHUD_PLAYER.HPB_Tex", WLHUD_PLAYER.HPB, CT_TEXTURE ))
		:SetDimensions(WLHUD_SAVE.Player_HPBar_Width,26 + WLHUD_SAVE.PlayerHP_Height)
		:SetTexture(WLHUD_PBars_Tex)
		:SetDrawLayer(4)
		:SetAnchor(LEFT, WLHUD_PLAYER.HP_Anchor, LEFT, 152,-1)
		:SetHidden(not WLHUD_SAVE.PlayerHP_Texture)
	.__END

	WLHUD_PLAYER.HPB_TexBG = WLHUD_Chain(WINDOW_MANAGER:CreateControl("WLHUD_PLAYER.HPB_TexBG", WLHUD_PLAYER.HPB, CT_BACKDROP ))
		:SetDimensions(WLHUD_SAVE.Player_HPBar_Width,22 + WLHUD_SAVE.PlayerHP_Height)
		:SetCenterColor(0,0,0,1)
		:SetEdgeColor(0,0,0,0)
		:SetEdgeTexture("", 1, 1,0)
		:SetDrawLayer(1)
		:SetAnchor(LEFT, WLHUD_PLAYER.HP_Anchor, LEFT, 152,-1)
	.__END

	WLHUD_PLAYER.HPReduc = WLHUD_Chain(WINDOW_MANAGER:CreateControl("WLHUD_PLAYER.HPReduc", WLHUD_PLAYER.HPB, CT_LABEL ))
		:SetFont(WLHUD_SAVE.Bars_Font)
		:SetDrawLayer(4)
		:SetAnchor(RIGHT, WLHUD_PLAYER.HPB_TexBG, RIGHT, 45,0)
		:SetScale(WLHUD_SAVE.Bars_Font_Size)
		:SetHidden(true)
	.__END
	
	--[[#############################################################################################################]]--
	--[[ MAGICKA ]]--
	--[[#############################################################################################################]]--
	WLHUD_PLAYER.MP_Anchor = WLHUD_Chain(WINDOW_MANAGER:CreateControl("WLHUD_PLAYER_MP_Anchor", WLHUD_PLAYER.Anchor, CT_TEXTURE ))
		:SetDimensions(25,25)
		:SetTexture(WLHUD_Anchor_Tex)
		:SetDrawLayer(4)
		:SetAnchor(TOPLEFT, GuiRoot, TOPLEFT, WLHUD_SAVE.Global_X + WLHUD_SAVE.PlayerMP_Anchor_X,WLHUD_SAVE.Global_Y + WLHUD_SAVE.PlayerMP_Anchor_Y)
		:SetHidden(true)
	.__END

	WLHUD_PLAYER.MPB = WLHUD_Chain(WINDOW_MANAGER:CreateControl("WLHUD_PLAYER.MPB", WLHUD_PLAYER.Anchor, CT_STATUSBAR))
		:SetColor(0.1,0.1,0.6,0.65)
		:SetDrawLayer(2)
		:SetDimensions(WLHUD_SAVE.Player_MPBar_Width,20 + WLHUD_SAVE.PlayerMP_Height)
		:SetAnchor(LEFT, WLHUD_PLAYER_MP_Anchor, LEFT, 152,0)
	.__END
	
	WLHUD_PLAYER.MPB_BG = WLHUD_Chain(WINDOW_MANAGER:CreateControl("WLHUD_PLAYER.MPB_BG", WLHUD_PLAYER.MPB, CT_TEXTURE ))
		:SetDimensions(WLHUD_SAVE.Player_MPBar_Width + 140,55)
		:SetTexture("/esoui/art/miscellaneous/singlelinesection_left.dds")
		:SetDrawLayer(1)
		:SetAnchor(LEFT, WLHUD_PLAYER_MP_Anchor, LEFT, 12,12)
		:SetHidden(not WLHUD_SAVE.Player_MP_Enable)
	.__END
	
	WLHUD_PLAYER.MPBT = WLHUD_Chain(WINDOW_MANAGER:CreateControl("WLHUD_PLAYER.MPBT", WLHUD_PLAYER.MPB, CT_LABEL ))
		:SetFont(WLHUD_SAVE.Bars_Font)
		:SetDrawLayer(4)
		:SetText(WLHUD_PLAYER.MPText)
		:SetAnchor(LEFT, WLHUD_PLAYER_MP_Anchor, LEFT, 60,0)
		:SetScale(WLHUD_SAVE.Bars_Font_Size)
		:SetHidden(not WLHUD_SAVE.Player_MP_Enable)
	.__END
	
	WLHUD_PLAYER.MPPerc = WLHUD_Chain(WINDOW_MANAGER:CreateControl("WLHUD_PLAYER.MPPerc", WLHUD_PLAYER.MPB, CT_LABEL ))
		:SetFont(WLHUD_SAVE.Bars_Font)
		:SetDrawLayer(4)
		:SetText("100 %")
		:SetAnchor(LEFT, WLHUD_PLAYER_MP_Anchor, LEFT, (WLHUD_SAVE.Player_MPBar_Width / 450) * WLHUD_SAVE.Player_MPPerc_X + 152,0)
		:SetScale(WLHUD_SAVE.Bars_Font_Size)
	.__END

	WLHUD_PLAYER.MPB_Tex = WLHUD_Chain(WINDOW_MANAGER:CreateControl("WLHUD_PLAYER.MPB_Tex", WLHUD_PLAYER.MPB, CT_TEXTURE ))
		:SetDimensions(WLHUD_SAVE.Player_MPBar_Width,27 + WLHUD_SAVE.PlayerMP_Height)
		:SetTexture(WLHUD_PBars_Tex)
		:SetDrawLayer(4)
		:SetAnchor(LEFT, WLHUD_PLAYER_MP_Anchor, LEFT, 152,-1)
		:SetHidden(not WLHUD_SAVE.PlayerMP_Texture)
	.__END

	WLHUD_PLAYER.MPB_TexBG = WLHUD_Chain(WINDOW_MANAGER:CreateControl("WLHUD_PLAYER.MPB_TexBG", WLHUD_PLAYER.MPB, CT_BACKDROP ))
		:SetDimensions(WLHUD_SAVE.Player_MPBar_Width,22 + WLHUD_SAVE.PlayerMP_Height)
		:SetCenterColor(0,0,0,1)
		:SetEdgeTexture("", 1, 1,0)
		:SetDrawLayer(1)
		:SetAnchor(LEFT, WLHUD_PLAYER_MP_Anchor, LEFT, 152,-1)
		:SetEdgeColor(0,0,0,0)
	.__END

	--[[#############################################################################################################]]--
	--[[ STAMINA ]]--
	--[[#############################################################################################################]]--
	WLHUD_PLAYER.SP_Anchor = WLHUD_Chain(WINDOW_MANAGER:CreateControl("WLHUD_PLAYER.SP_Anchor", WLHUD_PLAYER.Anchor, CT_TEXTURE ))
		:SetDimensions(25,25)
		:SetTexture(WLHUD_Anchor_Tex)
		:SetDrawLayer(4)
		:SetAnchor(TOPLEFT, GuiRoot, TOPLEFT, WLHUD_SAVE.Global_X + WLHUD_SAVE.PlayerSP_Anchor_X,WLHUD_SAVE.Global_Y + WLHUD_SAVE.PlayerSP_Anchor_Y)
		:SetHidden(true)
	.__END

	WLHUD_PLAYER.SPB = WLHUD_Chain(WINDOW_MANAGER:CreateControl("WLHUD_PLAYER.SPB", WLHUD_PLAYER.Anchor, CT_STATUSBAR))
		:SetColor(0.1,0.6,0.1,0.65)
		:SetDrawLayer(2)
		:SetDimensions(WLHUD_SAVE.Player_SPBar_Width,20 + WLHUD_SAVE.PlayerSP_Height)
		:SetAnchor(LEFT, WLHUD_PLAYER.SP_Anchor, LEFT, 152,0)
	.__END
	
	WLHUD_PLAYER.SPB_BG = WLHUD_Chain(WINDOW_MANAGER:CreateControl("WLHUD_PLAYER.SPB_BG", WLHUD_PLAYER.SPB, CT_TEXTURE ))
		:SetDimensions(WLHUD_SAVE.Player_SPBar_Width + 140,55)
		:SetTexture("/esoui/art/miscellaneous/singlelinesection_left.dds")
		:SetDrawLayer(0)
		:SetAnchor(LEFT, WLHUD_PLAYER.SP_Anchor, LEFT, 12,12)
		:SetHidden(not WLHUD_SAVE.Player_SP_Enable)
	.__END
	
	WLHUD_PLAYER.SPBT = WLHUD_Chain(WINDOW_MANAGER:CreateControl("WLHUD_PLAYER.SPBT", WLHUD_PLAYER.SPB, CT_LABEL ))
		:SetFont(WLHUD_SAVE.Bars_Font)
		:SetDrawLayer(4)
		:SetText(WLHUD_PLAYER.SPText)
		:SetAnchor(LEFT, WLHUD_PLAYER.SP_Anchor, LEFT, 60,0)
		:SetScale(WLHUD_SAVE.Bars_Font_Size)
		:SetHidden(not WLHUD_SAVE.Player_SP_Enable)
	.__END
	
	WLHUD_PLAYER.SPPerc = WLHUD_Chain(WINDOW_MANAGER:CreateControl("WLHUD_PLAYER.SPPerc", WLHUD_PLAYER.SPB, CT_LABEL ))
		:SetFont(WLHUD_SAVE.Bars_Font)
		:SetDrawLayer(4)
		:SetText("100 %")
		:SetAnchor(LEFT, WLHUD_PLAYER.SP_Anchor, LEFT, (WLHUD_SAVE.Player_SPBar_Width / 450) * WLHUD_SAVE.Player_SPPerc_X + 152,0)
		:SetScale(WLHUD_SAVE.Bars_Font_Size)
	.__END

	WLHUD_PLAYER.SPB_Tex = WLHUD_Chain(WINDOW_MANAGER:CreateControl("WLHUD_PLAYER.SPB_Tex", WLHUD_PLAYER.SPB, CT_TEXTURE ))
		:SetDimensions(WLHUD_SAVE.Player_SPBar_Width,27 + WLHUD_SAVE.PlayerSP_Height)
		:SetTexture(WLHUD_PBars_Tex)
		:SetDrawLayer(4)
		:SetAnchor(LEFT, WLHUD_PLAYER.SP_Anchor, LEFT, 152,-1)
		:SetHidden(not WLHUD_SAVE.PlayerSP_Texture)
	.__END

	WLHUD_PLAYER.SPB_TexBG = WLHUD_Chain(WINDOW_MANAGER:CreateControl("WLHUD_PLAYER.SPB_TexBG", WLHUD_PLAYER.SPB, CT_BACKDROP ))
		:SetDimensions(WLHUD_SAVE.Player_SPBar_Width,22 + WLHUD_SAVE.PlayerSP_Height)
		:SetCenterColor(0,0,0,1)
		:SetEdgeTexture("", 1, 1,0)
		:SetDrawLayer(1)
		:SetAnchor(LEFT, WLHUD_PLAYER.SP_Anchor, LEFT, 152,-1)
		:SetEdgeColor(0,0,0,0)
	.__END
	
	--[[#############################################################################################################]]--
	--[[ HORSE ]]--
	--[[#############################################################################################################]]--
	WLHUD_PLAYER.Horse_Anchor = WLHUD_Chain(WINDOW_MANAGER:CreateControl("WLHUD_PLAYER.Horse_Anchor", WLHUD_PLAYER.Anchor, CT_TEXTURE ))
		:SetDimensions(25,25)
		:SetTexture(WLHUD_Anchor_Tex)
		:SetDrawLayer(4)
		:SetAnchor(TOPLEFT, GuiRoot, TOPLEFT, WLHUD_SAVE.Global_X + WLHUD_SAVE.Horse_Anchor_X,WLHUD_SAVE.Global_Y + WLHUD_SAVE.Horse_Anchor_Y)
		:SetHidden(true)
	.__END

	WLHUD_PLAYER.Horse_SPB = WLHUD_Chain(WINDOW_MANAGER:CreateControl("WLHUD_PLAYER.Horse_SPB", WLHUD_PLAYER.SPB, CT_STATUSBAR))
		-- :SetColor(0.1,0.6,0.1,0.65)
		:SetGradientColors(GetInterfaceColor(INTERFACE_COLOR_TYPE_POWER_START, POWERTYPE_MOUNT_STAMINA))
		:SetDrawLayer(2)
		:SetDimensions(270,20)
		:SetAnchor(LEFT, WLHUD_PLAYER.Horse_Anchor, LEFT, 62,0)
		:SetHidden(true)
	.__END

	WLHUD_PLAYER.Horse_SPB_BG = WLHUD_Chain(WINDOW_MANAGER:CreateControl("WLHUD_PLAYER.Horse_SPB_BG", WLHUD_PLAYER.Horse_SPB, CT_BACKDROP))
		:SetCenterColor(0,0,0,0.5)
		:SetEdgeColor(0,0,0,1)
		:SetEdgeTexture("", 8, 1, 1)
		:SetDrawLayer(0)
		:SetDimensions(274,24)
		:SetAnchor(LEFT, WLHUD_PLAYER.Horse_Anchor, LEFT, 60,0)
	.__END
	
	WLHUD_PLAYER.Horse_icon = WLHUD_Chain(WINDOW_MANAGER:CreateControl("WLHUD_PLAYER.Horse_icon", WLHUD_PLAYER.Horse_SPB, CT_TEXTURE ))
		:SetColor(1,1,1,1)
		:SetDimensions(32,32)
		:SetTexture("/esoui/art/mounts/tabicon_mounts_down.dds")
		:SetAnchor(LEFT, WLHUD_PLAYER.Horse_SPB, LEFT, -34,0)
	.__END

	--[[#############################################################################################################]]--
	--[[ PET ]]--
	--[[#############################################################################################################]]--
	WLHUD_PlayerPet_HPBT = WLHUD_Chain(WINDOW_MANAGER:CreateControl("WLHUD_PlayerPet_HPBT", WLHUD_PLAYER.HPB, CT_LABEL ))
		:SetFont(WLHUD_SAVE.Bars_Font)
		:SetDrawLayer(4)
		:SetAnchor(CENTER, GuiRoot, CENTER, 0,0)
		:SetScale(WLHUD_SAVE.Bars_Font_Size)
	.__END
end --WLHUD_PLAYER:Create()

-- function WLHUD_PLAYER:Create_Buffs()
-- 	WLHUD_PLAYER.Buff_MW = WLHUD_Chain(WINDOW_MANAGER:CreateTopLevelWindow("WLHUD_PLAYER_Buff_MW"))
-- 		:SetAnchor(TOPLEFT,GuiRoot,TOPLEFT, WLHUD_SAVE.Global_X + WLHUD_SAVE.PlayerBuffs_X,WLHUD_SAVE.Global_Y + WLHUD_SAVE.PlayerBuffs_Y)
-- 		:SetDimensions(300, 44)
-- 		:SetScale(WLHUD_SAVE.PBuff_Scale)
-- 	.__END
	
-- 	WLHUD_PLAYER.Buff_BG = WLHUD_Chain(WINDOW_MANAGER:CreateControl("WLHUD_PLAYER.Buff_BG", WLHUD_PLAYER.Buff_MW, CT_BACKDROP))
-- 		:SetCenterColor(0.13, 0.6, 0.13,0.25)
-- 		:SetEdgeColor(0.13, 0.8, 0.13,1)
-- 		:SetEdgeTexture("", 8, 1, 1)
-- 		:SetDrawLayer(1)
-- 		:SetAnchorFill(WLHUD_PLAYER.Buff_MW)
-- 		:SetHidden(true)
-- 	.__END

-- 	WLHUD_PLAYER.Buff_MW_LBL = WLHUD_Chain(WINDOW_MANAGER:CreateControl("WLHUD_PLAYER.Buff_MW_LBL", WLHUD_PLAYER.Buff_MW, CT_LABEL ))
-- 		:SetColor(0.13, 0.8, 0.13, 1)
-- 		:SetFont(WLHUD_SAVE.Bars_Font)
-- 		:SetDrawLayer(4)
-- 		:SetText(WLHUD_PLAYER.Buff_MW_Text)
-- 		:SetAnchor(CENTER, WLHUD_PLAYER.Buff_MW, CENTER, 0,0)
-- 		:SetHidden(true)
-- 	.__END

-- 	WLHUD_PLAYER.Buff_Anchor = WLHUD_Chain(WINDOW_MANAGER:CreateControl("WLHUD_PLAYER.Buff_Anchor", WLHUD_PLAYER.Buff_BG, CT_TEXTURE ))
-- 		:SetDimensions(25,25)
-- 		:SetTexture(WLHUD_Anchor_Tex)
-- 		:SetDrawLayer(4)
-- 		:SetAnchor(TOPLEFT, WLHUD_PLAYER.Buff_BG, TOPLEFT, 5,5)
-- 		:SetHidden(true)
-- 	.__END
	
-- 	WLHUD_PLAYER.DeBuff_MW = WLHUD_Chain(WINDOW_MANAGER:CreateTopLevelWindow("WLHUD_PLAYER_DeBuff_MW"))
-- 		:SetAnchor(TOPLEFT,GuiRoot,TOPLEFT, WLHUD_SAVE.Global_X + WLHUD_SAVE.PlayerDEBuffs_X,WLHUD_SAVE.Global_Y + WLHUD_SAVE.PlayerDEBuffs_Y)
-- 		:SetDimensions(300, 44)
-- 		:SetScale(WLHUD_SAVE.PDEBuff_Scale)
-- 	.__END
	
-- 	WLHUD_PLAYER.DeBuff_BG = WLHUD_Chain(WINDOW_MANAGER:CreateControl("WLHUD_PLAYER.DeBuff_BG", WLHUD_PLAYER.DeBuff_MW, CT_BACKDROP))
-- 		:SetCenterColor(0.6,0.13,0.13,0.25)
-- 		:SetEdgeColor(0.6,0.13,0.13,1)
-- 		:SetEdgeTexture("", 8, 1, 1)
-- 		:SetDrawLayer(1)
-- 		:SetAnchorFill(WLHUD_PLAYER.DeBuff_MW)
-- 		:SetHidden(true)
-- 	.__END
	
-- 	WLHUD_PLAYER.DeBuff_MW_LBL = WLHUD_Chain(WINDOW_MANAGER:CreateControl("WLHUD_PLAYER.DeBuff_MW_LBL", WLHUD_PLAYER.DeBuff_MW, CT_LABEL ))
-- 		:SetColor(0.8, 0.13, 0.13, 1)
-- 		:SetFont(WLHUD_SAVE.Bars_Font)
-- 		:SetDrawLayer(4)
-- 		:SetText(WLHUD_PLAYER.DeBuff_MW_Text)
-- 		:SetAnchor(CENTER, WLHUD_PLAYER.DeBuff_MW, CENTER, 0,0)
-- 		:SetHidden(true)
-- 	.__END

-- 	WLHUD_PLAYER.DeBuff_Anchor = WLHUD_Chain(WINDOW_MANAGER:CreateControl("WLHUD_PLAYER.DeBuff_Anchor", WLHUD_PLAYER.DeBuff_BG, CT_TEXTURE ))
-- 		:SetDimensions(25,25)
-- 		:SetTexture(WLHUD_Anchor_Tex)
-- 		:SetDrawLayer(4)
-- 		:SetAnchor(TOPLEFT, WLHUD_PLAYER.DeBuff_BG, TOPLEFT, 5,5)
-- 		:SetHidden(true)
-- 	.__END

-- 	--[[#############################################################################################################]]--
-- 	--[[ PREVIEW ]]--
-- 	--[[#############################################################################################################]]--
-- 	WLHUD_PreviewBuff_MW = WLHUD_Chain(WINDOW_MANAGER:CreateTopLevelWindow("WLHUD_PreviewBuff_MW"))
-- 		:SetAnchor(TOPLEFT,GuiRoot,TOPLEFT, WLHUD_SAVE.Global_X + WLHUD_SAVE.PlayerBuffs_X,WLHUD_SAVE.Global_Y + WLHUD_SAVE.PlayerBuffs_Y)
-- 		:SetDimensions(300, 44)
-- 		:SetScale(WLHUD_SAVE.PBuff_Scale)
-- 		:SetHidden(true)
-- 	.__END

-- 	WLHUD_PBuff_PreviewBG = WLHUD_Chain(WINDOW_MANAGER:CreateControl("WLHUD_PBuff_PreviewBG", WLHUD_PreviewBuff_MW, CT_BACKDROP ))
-- 		:SetDimensions(44,44)
-- 		:SetDrawLayer(1)
-- 		:SetAnchor(RIGHT, WLHUD_PLAYER.Buff_MW, RIGHT, -2, -3)
-- 		:SetEdgeTexture("", 8, 1, 3)
-- 		:SetEdgeColor(WLHUD_SAVE.PBuff_BG_R, WLHUD_SAVE.PBuff_BG_G, WLHUD_SAVE.PBuff_BG_B,1)
-- 		:SetCenterColor(0.13,0.13,0.13,1)
-- 	.__END
	
-- 	WLHUD_PBuff_Preview = WLHUD_Chain(WINDOW_MANAGER:CreateControl("WLHUD_PBuff_Preview", WLHUD_PBuff_PreviewBG, CT_TEXTURE ))
-- 		:SetColor(1,1,1,1)
-- 		:SetDimensions(36,36)
-- 		:SetDrawLayer(3)
-- 		:SetTexture("/esoui/art/icons/ability_sorcerer_038.dds")
-- 		:SetAnchor(CENTER, WLHUD_PBuff_PreviewBG, CENTER, 0, 0)
-- 	.__END

-- 	WLHUD_PBuff_Preview_LBL = WLHUD_Chain(WINDOW_MANAGER:CreateControl("WLHUD_PBuff_Preview_LVL", WLHUD_PBuff_PreviewBG, CT_LABEL ))
-- 		:SetFont("ZoFontBossName")
-- 		:SetDimensions(45,25)
-- 		:SetDrawLayer(4)
-- 		:SetAnchor(BOTTOM, WLHUD_PBuff_PreviewBG, BOTTOM, 5,25)
-- 		:SetColor(WLHUD_SAVE.PBuff_R, WLHUD_SAVE.PBuff_G, WLHUD_SAVE.PBuff_B, 1)
-- 	.__END

-- 	WLHUD_PreviewDEBuff_MW = WLHUD_Chain(WINDOW_MANAGER:CreateTopLevelWindow("WLHUD_PreviewDEBuff_MW"))
-- 		:SetAnchor(TOPLEFT,GuiRoot,TOPLEFT, WLHUD_SAVE.Global_X + WLHUD_SAVE.PlayerDEBuffs_X,WLHUD_SAVE.Global_Y + WLHUD_SAVE.PlayerDEBuffs_Y)
-- 		:SetDimensions(300, 44)
-- 		:SetScale(WLHUD_SAVE.PDEBuff_Scale)
-- 		:SetHidden(true)
-- 	.__END
	
-- 	WLHUD_PDEBuff_PreviewBG = WLHUD_Chain(WINDOW_MANAGER:CreateControl("WLHUD_PDEBuff_PreviewBG", WLHUD_PreviewDEBuff_MW, CT_BACKDROP ))
-- 		:SetDimensions(44,44)
-- 		:SetDrawLayer(1)
-- 		:SetAnchor(RIGHT, WLHUD_PLAYER.DeBuff_MW, RIGHT, -2, -3)
-- 		:SetEdgeTexture("", 8, 1, 3)
-- 		:SetEdgeColor(WLHUD_SAVE.PDEBuff_BG_R, WLHUD_SAVE.PDeBuff_BG_G, WLHUD_SAVE.PDEBuff_BG_B,1)
-- 		:SetCenterColor(0.13,0.13,0.13,1)
-- 	.__END
	
-- 	WLHUD_PDEBuff_Preview = WLHUD_Chain(WINDOW_MANAGER:CreateControl("WLHUD_PDEBuff_Preview", WLHUD_PDEBuff_PreviewBG, CT_TEXTURE ))
-- 		:SetColor(1,1,1,1)
-- 		:SetDimensions(36,36)
-- 		:SetDrawLayer(3)
-- 		:SetTexture("/esoui/art/icons/ability_1handed_002.dds")
-- 		:SetAnchor(CENTER, WLHUD_PDEBuff_PreviewBG, CENTER, 0, 0)
-- 	.__END

-- 	WLHUD_PDEBuff_Preview_LBL = WLHUD_Chain(WINDOW_MANAGER:CreateControl("WLHUD_PDEBuff_Preview_LBL", WLHUD_PDEBuff_PreviewBG, CT_LABEL ))
-- 		:SetFont("ZoFontBossName")
-- 		:SetDimensions(45,25)
-- 		:SetDrawLayer(4)
-- 		:SetAnchor(BOTTOM, WLHUD_PDEBuff_PreviewBG, BOTTOM, 5,25)
-- 		:SetColor(WLHUD_SAVE.PDEBuff_R, WLHUD_SAVE.PDEBuff_G, WLHUD_SAVE.PDEBuff_B, 1)
-- 	.__END
-- end --WLHUD_PLAYER:Create_Buffs()

-- function WLHUD_PLAYER:Create_CastBar()
-- 	local WLHUD_Anchor_Tex = "WarLegendHUD/img/anchor.dds"
-- 	WLHUD_PLAYER.Cast_Anchor = WLHUD_Chain(WINDOW_MANAGER:CreateControl("WLHUD_PLAYER.Cast_Anchor", WLHUD_PLAYER.Anchor, CT_TEXTURE ))
-- 		:SetDimensions(25,25)
-- 		:SetTexture(WLHUD_Anchor_Tex)
-- 		:SetDrawLayer(4)
-- 		:SetAnchor(TOPLEFT, GuiRoot, TOPLEFT, WLHUD_SAVE.Global_X + WLHUD_SAVE.PlayerCast_Anchor_X,WLHUD_SAVE.Global_Y + WLHUD_SAVE.PlayerCast_Anchor_Y)
-- 		:SetHidden(true)
-- 	.__END

-- 	WLHUD_PlayerCastAnchor = WLHUD_Chain(WINDOW_MANAGER:CreateControl("WLHUD_PlayerCastAnchor", WLHUD_PLAYER.Anchor, CT_BACKDROP))
-- 		:SetCenterColor(0.6, 0.13, 0.13, 0)
-- 		:SetEdgeColor(0.8, 0.13, 0.13, 0)
-- 		:SetEdgeTexture("", 8, 1, 0)
-- 		:SetDrawLayer(1)
-- 		:SetDimensions(450,20)
-- 		:SetAnchor(LEFT, WLHUD_PLAYER.Cast_Anchor, LEFT, 27,5)
-- 	.__END
	
-- 	WLHUD_PlayerCast_Bar = WLHUD_Chain(WINDOW_MANAGER:CreateControl("WLHUD_PlayerCast_Bar", WLHUD_PlayerCastAnchor, CT_STATUSBAR))
-- 		:SetDrawLayer(3)
-- 		:SetDimensions(WLHUD_SAVE.Player_CatBar_Width, 20)
-- 		:SetAnchor(TOPLEFT, WLHUD_PlayerCastAnchor, TOPLEFT, 0,0)
-- 		:SetGradientColors(WLHUD_SAVE.PCastE_R, WLHUD_SAVE.PCastE_G, WLHUD_SAVE.PCastE_B1,1 ,WLHUD_SAVE.PCastS_R, WLHUD_SAVE.PCastS_G, WLHUD_SAVE.PCastS_B,1)
-- 	.__END
	
-- 	WLHUD_PLAYER.Cast_BG = WLHUD_Chain(WINDOW_MANAGER:CreateControl("WLHUD_PLAYER.Cast_BG", WLHUD_PlayerCastAnchor, CT_TEXTURE ))
-- 		:SetDimensions(WLHUD_SAVE.Player_CatBar_Width,55)
-- 		:SetColor(0.682,0.537,0.392, 1)
-- 		:SetTexture("/esoui/art/miscellaneous/singlelinesection_left.dds")
-- 		:SetDrawLayer(2)
-- 		:SetAnchor(TOPLEFT, WLHUD_PlayerCastAnchor, TOPLEFT, 0,-5)
-- 	.__END

-- 	WLHUD_PLAYER.CastLBL = WLHUD_Chain(WINDOW_MANAGER:CreateControl("WLHUD_PLAYER.CastLBL", WLHUD_PlayerCastAnchor, CT_LABEL ))
-- 		:SetFont("ZoFontAnnounceSmall")
-- 		:SetDrawLayer(4)
-- 		:SetAnchor(CENTER, WLHUD_PLAYER.Cast_BG, CENTER, 0,-15)
-- 		:SetScale(WLHUD_SAVE.Bars_Font_Size)
-- 	.__END
-- end --WLHUD_PLAYER:Create_CastBar()

function WLHUD_PLAYER:Create_Shield()
	WLHUD_PLAYER.Shield = WLHUD_Chain(WINDOW_MANAGER:CreateControl("WLHUD_PLAYER.Shield", WLHUD_PLAYER.Anchor, CT_LABEL ))
		:SetFont("ZoFontBossName")
		:SetDrawLayer(4)
		:SetText(WLHUD_PLAYER.ShieldText)
		:SetAnchor(LEFT, WLHUD_PLAYER.HP_Anchor, LEFT, 0,-25)
		:SetHidden(true)
	.__END
	
	WLHUD_PLAYER.Shield_Value = WLHUD_Chain(WINDOW_MANAGER:CreateControl("WLHUD_PLAYER.Shield_Value", WLHUD_PLAYER.Anchor, CT_LABEL ))
		:SetFont("ZoFontAlert")
		:SetDrawLayer(4)
		:SetAnchor(LEFT, WLHUD_PLAYER.HP_Anchor, LEFT, 100,-25)
		:SetColor(0.901,0.494,0.188, 1)
		:SetHidden(true)
	.__END
	
	WLHUD_PlayerShield_Bar = WLHUD_Chain(WINDOW_MANAGER:CreateControl("WLHUD_PlayerShield_Bar", WLHUD_PLAYER.Anchor, CT_STATUSBAR))
		:SetDrawLayer(3)
		:SetDimensions(0, 15)
		:SetAnchor(TOPRIGHT, WLHUD_PLAYER.HPB_Tex, TOPRIGHT, 0,10)
		:SetGradientColors(0.300,0.800,0.900,0.58, 0.300,0.800,0.900,1)
		:SetHidden(true)
	.__END
end --WLHUD_PLAYER:Create_Shield()