local function WLHUD_Chain( object )
	
	-- Setup the metatable
	local T = {}
	setmetatable( T, { __index = function( self, func )
		
		-- Know when to stop chaining
		if func == "__END" then	return object end
		
		-- Otherwise, add the method to the parent object
		return function( self, ... )
			assert( object[func], func .. " missing in object" )
			object[func]( object, ... )
			return self
		end
	end })
	
	-- Return the metatable
	return T
end

function WLHUD_SIEGE:Create()
	WLHUD_SIEGE.Anchor = WLHUD_Chain(WINDOW_MANAGER:CreateTopLevelWindow("WLHUD_SIEGE.Anchor"))
		:SetAnchor(TOPLEFT,WLHUD_PLAYER.HPB,TOPLEFT, 0,35)
	.__END

	WLHUD_SIEGE.HPB = WLHUD_Chain(WINDOW_MANAGER:CreateControl("WLHUD_SIEGE.HP", WLHUD_PLAYER.Anchor, CT_STATUSBAR))
		:SetDrawLayer(3)
		:SetDimensions(0, 20)
		:SetAnchor(TOPLEFT,WLHUD_PLAYER.HP_Anchor,TOPLEFT, 152,36)
		:SetGradientColors(0.6,0.1,0.1,1, 0.901,0.494,0.188,1)
		:SetHidden(true)
	.__END

	WLHUD_SIEGE.BG = WLHUD_Chain(WINDOW_MANAGER:CreateControl("WLHUD_SIEGE.BG", WLHUD_SIEGE.HPB, CT_BACKDROP))
		:SetCenterColor(0.13,0.13,0.13,0.8)
		:SetEdgeColor(1,1, 1,1)
		:SetEdgeTexture("", 8, 1, 2)
		:SetDrawLayer(1)
		:SetAnchor(TOPLEFT,WLHUD_PLAYER.HP_Anchor,TOPLEFT, 72,34)
		:SetDimensions(WLHUD_SAVE.Player_HPBar_Width + 84, 24)
	.__END

	WLHUD_SIEGE.LBL = WLHUD_Chain(WINDOW_MANAGER:CreateControl("WLHUD_SIEGE.LBL", WLHUD_SIEGE.HPB, CT_LABEL ))
		:SetFont(WLHUD_SAVE.Bars_Font)
		:SetDrawLayer(4)
		:SetText(WLHUD_SIEGE.Text)
		:SetAnchor(CENTER, WLHUD_SIEGE.BG, CENTER, 0,0)
	.__END

	WLHUD_SIEGE.Perc = WLHUD_Chain(WINDOW_MANAGER:CreateControl("WLHUD_SIEGE.Perc", WLHUD_SIEGE.HPB, CT_LABEL ))
		:SetFont(WLHUD_SAVE.Bars_Font)
		:SetDrawLayer(4)
		:SetAnchor(LEFT, WLHUD_SIEGE.BG, LEFT, 10,0)
	.__END
end --WLHUD_SIEGE:Create()