-- Create Labels and List --
-- local WLHUD_Logo_Tex = "WarLegendHUD/img/logo_wl.dds"

local function WLHUD_Chain( object )
	
	-- Setup the metatable
	local T = {}
	setmetatable( T, { __index = function( self, func )
		
		-- Know when to stop chaining
		if func == "__END" then	return object end
		
		-- Otherwise, add the method to the parent object
		return function( self, ... )
			assert( object[func], func .. " missing in object" )
			object[func]( object, ... )
			return self
		end
	end })
	
	-- Return the metatable
	return T
end

function WLHUD_SETTINGS_MWClose()
	WLHUD_SETTINGS_MW:SetHidden(true)
	WLHUD_PLAYER.Horse_SPB:SetHidden(true)
	WLHUD_TARGET.Anchor_Tex:SetHidden(true)

	WLHUD_PLAYER.HP_Anchor:SetHidden(true)
	WLHUD_PLAYER.HP_Anchor:SetMovable(false)
	WLHUD_PLAYER.HP_Anchor:SetMouseEnabled(false)

	WLHUD_PLAYER_MP_Anchor:SetHidden(true)
	WLHUD_PLAYER_MP_Anchor:SetMovable(false)
	WLHUD_PLAYER_MP_Anchor:SetMouseEnabled(false)

	WLHUD_PLAYER.SP_Anchor:SetHidden(true)
	WLHUD_PLAYER.SP_Anchor:SetMovable(false)
	WLHUD_PLAYER.SP_Anchor:SetMouseEnabled(false)

	WLHUD_PLAYER.Horse_Anchor:SetHidden(true)
	WLHUD_PLAYER.Horse_Anchor:SetMovable(false)
	WLHUD_PLAYER.Horse_Anchor:SetMouseEnabled(false)

	-- WLHUD_PLAYER.Cast_Anchor:SetHidden(true)
	-- WLHUD_PLAYER.Cast_Anchor:SetMovable(false)
	-- WLHUD_PLAYER.Cast_Anchor:SetMouseEnabled(false)
	
	WLHUD_TARGET.Anchor_BG:SetHidden(true)
	WLHUD_TARGET.Anchor:SetHidden(true)
	-- WLHUD_TARGET_T.Anchor:SetHidden(true)
	-- WLHUD_TARGET_T.BG:SetHidden(true)
	-- WLHUD_TARGET_T.Anchor_Tex:SetHidden(true)
	WLHUD_TARGET.AllyTex:SetHidden(true)
	-- WLHUD_PLAYER.Buff_BG:SetHidden(true)
	-- WLHUD_PLAYER.Buff_MW_LBL:SetHidden(true)
	-- WLHUD_PLAYER.DeBuff_BG:SetHidden(true)
	-- WLHUD_PLAYER.DeBuff_MW_LBL:SetHidden(true)
	-- WLHUD_TARGET.Buff_BG:SetHidden(true)
	-- WLHUD_TARGET.Buff_MW_LBL:SetHidden(true)
	-- WLHUD_TARGET.DeBuff_BG:SetHidden(true)
	-- WLHUD_TARGET.DeBuff_MW_LBL:SetHidden(true)
	WLHUD_TARGET.HP_Anchor:SetHidden(true)
	-- WLHUD_TARGET.MP_Anchor:SetHidden(true)
	-- WLHUD_TARGET.SP_Anchor:SetHidden(true)
	WLHUD_MESSAGE:SetHidden(true)
	WLHUD_MESSAGE.LBL:SetHidden(true)
	
	WLHUD_PLAYER.Anchor:SetMovable(false)
	WLHUD_PLAYER.Anchor:SetMouseEnabled(false)
	WLHUD_TARGET.Anchor:SetMovable(false)
	WLHUD_TARGET.Anchor:SetMouseEnabled(false)
	WLHUD_TARGET.HP_Anchor:SetMouseEnabled(false)
	-- WLHUD_TARGET.MP_Anchor:SetMouseEnabled(false)
	-- WLHUD_TARGET.SP_Anchor:SetMouseEnabled(false)
	-- WLHUD_TARGET_T.Anchor:SetMovable(false)
	-- WLHUD_TARGET_T.Anchor:SetMouseEnabled(false)
	-- WLHUD_PLAYER.Buff_MW:SetMovable(false)
	-- WLHUD_PLAYER.Buff_MW:SetMouseEnabled(false)
	-- WLHUD_PLAYER.DeBuff_MW:SetMovable(false)
	-- WLHUD_PLAYER.DeBuff_MW:SetMouseEnabled(false)
	-- WLHUD_TARGET.Buff_MW:SetMovable(false)
	-- WLHUD_TARGET.Buff_MW:SetMouseEnabled(false)
	-- WLHUD_TARGET.DeBuff_MW:SetMovable(false)
	-- WLHUD_TARGET.DeBuff_MW:SetMouseEnabled(false)
	WLHUD_MESSAGE:SetMovable(false)
	WLHUD_MESSAGE:SetMouseEnabled(false)
	
	WLHUD_SAVE.Lock_All_Frames = true
	
	d("|cB22222"..WLHUD_SAVE_Text)
	
	WLHUD_SETTINGS = 0

	-- if (ZO_OptionsWindow:IsHidden()) then WLHUD_SAVE.Enable_Preview = false end

	SetGameCameraUIMode(false)
end -- WLHUD_SETTINGS_MWClose()

local function WLHUD_PLAYER_HP_Anchor_MouseUp()
	local left = WLHUD_PLAYER.HP_Anchor:GetLeft()
	local top = WLHUD_PLAYER.HP_Anchor:GetTop()

	WLHUD_SAVE.PlayerHP_Anchor_X = left
	WLHUD_SAVE.PlayerHP_Anchor_Y = top
	
	SetGameCameraUIMode(true)
end --WLHUD_PLAYER.HP_Anchor_MouseUp()

local function WLHUD_PLAYER_MP_Anchor_MouseUp()
	local left = WLHUD_PLAYER.MP_Anchor:GetLeft()
	local top = WLHUD_PLAYER.MP_Anchor:GetTop()

	WLHUD_SAVE.PlayerMP_Anchor_X = left
	WLHUD_SAVE.PlayerMP_Anchor_Y = top
	
	SetGameCameraUIMode(true)
end --WLHUD_PLAYER_MP_Anchor_MouseUp()

local function WLHUD_PLAYER_SP_Anchor_MouseUp()
	local left = WLHUD_PLAYER.SP_Anchor:GetLeft()
	local top = WLHUD_PLAYER.SP_Anchor:GetTop()

	WLHUD_SAVE.PlayerSP_Anchor_X = left
	WLHUD_SAVE.PlayerSP_Anchor_Y = top
	
	SetGameCameraUIMode(true)
end --WLHUD_PLAYER_SP_Anchor_MouseUp()

local function WLHUD_PLAYER_Horse_Anchor_MouseUp()
	local left = WLHUD_PLAYER.Horse_Anchor:GetLeft()
	local top = WLHUD_PLAYER.Horse_Anchor:GetTop()

	WLHUD_SAVE.Horse_Anchor_X = left
	WLHUD_SAVE.Horse_Anchor_Y = top
	
	SetGameCameraUIMode(true)
end --WLHUD_PLAYER_Horse_Anchor_MouseUp()

-- local function WLHUD_PLAYER_Cast_Anchor_MouseUp()
-- 	local left = WLHUD_PLAYER.Cast_Anchor:GetLeft()
-- 	local top = WLHUD_PLAYER.Cast_Anchor:GetTop()

-- 	WLHUD_SAVE.PlayerCast_Anchor_X = left
-- 	WLHUD_SAVE.PlayerCast_Anchor_Y = top
	
-- 	SetGameCameraUIMode(true)
-- end --WLHUD_PLAYER.Cast_Anchor_MouseUp()

local function WLHUD_TARGET_Anchor_MouseUp()
	local left = WLHUD_TARGET.Anchor:GetLeft()
	local top = WLHUD_TARGET.Anchor:GetTop()

	WLHUD_SAVE.Target_Anchor_X = left
	WLHUD_SAVE.Target_Anchor_Y = top
	
	SetGameCameraUIMode(true)
end --WLHUD_PLAYER.Anchor_MouseUp()

local function WLHUD_TARGET_HP_Anchor_MouseUp()
	local left = WLHUD_TARGET.HP_Anchor:GetLeft()
	local top = WLHUD_TARGET.HP_Anchor:GetTop()

	WLHUD_SAVE.TargetHP_Anchor_X = left
	WLHUD_SAVE.TargetHP_Anchor_Y = top
	
	SetGameCameraUIMode(true)
end --WLHUD_TARGET.HP_Anchor_MouseUp()

-- local function WLHUD_TARGET_MP_Anchor_MouseUp()
-- 	local left = WLHUD_TARGET.MP_Anchor:GetLeft()
-- 	local top = WLHUD_TARGET.MP_Anchor:GetTop()

-- 	WLHUD_SAVE.TargetMP_Anchor_X = left
-- 	WLHUD_SAVE.TargetMP_Anchor_Y = top
	
-- 	SetGameCameraUIMode(true)
-- end --WLHUD_TARGET_MP_Anchor_MouseUp()

-- local function WLHUD_TARGET_SP_Anchor_MouseUp()
-- 	local left = WLHUD_TARGET.SP_Anchor:GetLeft()
-- 	local top = WLHUD_TARGET.SP_Anchor:GetTop()

-- 	WLHUD_SAVE.TargetSP_Anchor_X = left
-- 	WLHUD_SAVE.TargetSP_Anchor_Y = top
	
-- 	SetGameCameraUIMode(true)
-- end --WLHUD_TARGET_SP_Anchor_MouseUp()

-- local function WLHUD_PLAYER_Buff_MW_MouseUp()
-- 	local left = WLHUD_PLAYER.Buff_MW:GetLeft()
-- 	local top = WLHUD_PLAYER.Buff_MW:GetTop()

-- 	WLHUD_SAVE.PlayerBuffs_X = left
-- 	WLHUD_SAVE.PlayerBuffs_Y = top
	
-- 	SetGameCameraUIMode(true)
-- end --WLHUD_PLAYER_Buff_MW_MouseUp()

-- local function WLHUD_PLAYER_DeBuff_MW_MouseUp()
-- 	local left = WLHUD_PLAYER.DeBuff_MW:GetLeft()
-- 	local top = WLHUD_PLAYER.DeBuff_MW:GetTop()

-- 	WLHUD_SAVE.PlayerDEBuffs_X = left
-- 	WLHUD_SAVE.PlayerDEBuffs_Y = top
	
-- 	SetGameCameraUIMode(true)
-- end --WLHUD_PLAYER_DeBuff_MW_MouseUp()

-- local function WLHUD_TARGET_Buff_MouseUp()
-- 	local left = WLHUD_TARGET.Buff_MW:GetLeft()
-- 	local top = WLHUD_TARGET.Buff_MW:GetTop()

-- 	WLHUD_SAVE.TargetBuffs_X = left
-- 	WLHUD_SAVE.TargetBuffs_Y = top
	
-- 	SetGameCameraUIMode(true)
-- end --WLHUD_TARGET_Buff_MouseUp()

-- local function WLHUD_TARGET_DeBuff_MW_MouseUp()
-- 	local left = WLHUD_TARGET.DeBuff_MW:GetLeft()
-- 	local top = WLHUD_TARGET.DeBuff_MW:GetTop()

-- 	WLHUD_SAVE.TargetDEBuffs_X = left
-- 	WLHUD_SAVE.TargetDEBuffs_Y = top
	
-- 	SetGameCameraUIMode(true)
-- end --WLHUD_TARGET_DeBuff_MW_MouseUp()

local function WLHUD_MESSAGE_MouseUp()
	local left = WLHUD_MESSAGE:GetLeft()
	local top = WLHUD_MESSAGE:GetTop()

	WLHUD_SAVE.SharedArea_X = left
	WLHUD_SAVE.SharedArea_Y = top
	
	SetGameCameraUIMode(true)
end --WLHUD_MESSAGE:MouseUp()

-- function WLHUD_TARGET_T.MouseUp()
-- 	local left = WLHUD_TARGET_T.Anchor:GetLeft()
-- 	local top = WLHUD_TARGET_T.Anchor:GetTop()

-- 	WLHUD_SAVE.TargetTarget_Anchor_X = left
-- 	WLHUD_SAVE.TargetTarget_Anchor_Y = top
	
-- 	SetGameCameraUIMode(true)
-- end --WLHUD_TARGET_T.MouseUp()

--[[----------------------------------------------------------
	INITIALIZATION
  ]]----------------------------------------------------------
function WLHUD_InitializeSettings()
	-- Settings Window
	WLHUD_SETTINGS_MW = WLHUD_Chain(WINDOW_MANAGER:CreateTopLevelWindow("WLHUD_SETTINGS_MW"))
		:SetDimensions(500,200)
		:SetAnchor(TOP,GuiRoot,TOP,0,400)
		:SetDrawLayer(0)
		:SetMouseEnabled(true)	
	.__END
	
	WLHUD_SETTINGS_MW_BG = WLHUD_Chain(WINDOW_MANAGER:CreateControl("WLHUD_SETTINGS_MW_BG", WLHUD_SETTINGS_MW, CT_BACKDROP))
		:SetAnchorFill(WLHUD_SETTINGS_MW)
		:SetCenterColor(0.1,0.1,0.1,0.75)
		:SetEdgeColor(0,0,0,1)
		:SetEdgeTexture("", 8, 1, 1)
		:SetAlpha(0.75)
		:SetDrawLayer(1)
		:SetAnchorFill(WLHUD_SETTINGS_MW)
		:SetMouseEnabled(true)
	.__END
	
	WLHUD_SETTINGS_MW_Title = WLHUD_Chain(WINDOW_MANAGER:CreateControl("WLHUD_SETTINGS_MW_Title", WLHUD_SETTINGS_MW, CT_LABEL))
		:SetFont("ZoFontBookTablet")
		:SetColor(255,255,255,255)
		:SetText(WLHUD_SETTINGS_MW_Text)
		:SetAnchor(TOP,WLHUD_SETTINGS_MW,TOP,0,0)
		:SetDrawLayer(2)
	.__END
	
	WLHUD_SETTINGS_MW_Version = WLHUD_Chain(WINDOW_MANAGER:CreateControl("WLHUD_SETTINGS_MW_Version", WLHUD_SETTINGS_MW, CT_LABEL))
		:SetFont("ZoFontAnnounceSmall")
		:SetColor(255,255,255,255)
		:SetText("v"..WLHUD_VERSION)
		:SetAnchor(TOPRIGHT,WLHUD_SETTINGS_MW,TOPRIGHT,-5,30)
		:SetDrawLayer(2)
	.__END
	
	WLHUD_Move_LBL = WLHUD_Chain(WINDOW_MANAGER:CreateControl("WLHUD_Move_LBL", WLHUD_SETTINGS_MW, CT_LABEL ))
		:SetFont("ZoFontAnnounceMedium")
		:SetDrawLayer(2)
		:SetText(WLHUD_Move_Text)
		:SetAnchor(TOPLEFT, WLHUD_SETTINGS_MW, TOPLEFT, 5,50)
	.__END
	
	WLHUD_Reset_Pos_B = WLHUD_Chain(WINDOW_MANAGER:CreateControl("WLHUD_Reset_Pos_B", WLHUD_SETTINGS_MW, CT_BUTTON))
		:SetDimensions(350,25)
		:SetAnchor(TOPLEFT, WLHUD_SETTINGS_MW ,TOPLEFT, 5,100)
		:SetFont("ZoFontAnnounceMedium")
		:SetText(WLHUD_Reset_Text)
		-- :SetScale(0.75)
		:SetDrawLayer(3)
		:SetNormalFontColor(0.85,0.6,0.13,1)
		:SetMouseOverFontColor(1,0.13,0.13,1)
		:SetHandler("OnClicked", function(self) WLHUD_Reset_All_Positions() end)
	.__END

	WLHUD_Logo = WLHUD_Chain(WINDOW_MANAGER:CreateControl("WLHUD_Logo", WLHUD_SETTINGS_MW, CT_TEXTURE ))
		:SetTexture("WarLegendHUD/img/logo_wl.dds")
		:SetColor(1,1,1,1)
		:SetDimensions(320,80)
		:SetDrawLayer(3)
		:SetAnchor(BOTTOMLEFT,WLHUD_SETTINGS_MW,BOTTOMLEFT,-50,15)
	.__END
	
	-- Close Button ------
	WLHUD_SETTINGS_MW_close = WLHUD_Chain(WINDOW_MANAGER:CreateControl("WLHUD_SETTINGS_MW_close", WLHUD_SETTINGS_MW, CT_BUTTON))
		:SetDimensions(75,50)
		:SetAnchor(BOTTOMRIGHT, WLHUD_SETTINGS_MW ,BOTTOMRIGHT, -10,15)
		:SetFont("ZoFontAnnounceMedium")
		:SetText(WLHUD_Close_Text)
		:SetDrawLayer(3)
		:SetScale(0.80)
		:SetMouseOverFontColor(0.8,0.4,0,1)
		:SetHandler("OnClicked", function(self) WLHUD_SETTINGS_MWClose() end)
	.__END
	
	WLHUD_Toggle_Settings()
end -- WLHUD_InitializeSettings()

function WLHUD_Toggle_Settings()
	WLHUD_SETTINGS = 1

	WLHUD_SETTINGS_MW:SetHidden(false)
	WLHUD_PLAYER.Horse_SPB:SetHidden(false)
	WLHUD_TARGET.Anchor_Tex:SetHidden(false)

	WLHUD_TARGET.Anchor_BG:SetHidden(false)
	WLHUD_TARGET.AllyTex:SetHidden(false)
	WLHUD_TARGET.AllyTex:SetTexture("/esoui/art/ava/ava_allianceflag_ebonheart.dds")
	
	WLHUD_PLAYER.Anchor:SetHidden(false)

	WLHUD_PLAYER.HP_Anchor:SetHidden(false)
	WLHUD_PLAYER.HP_Anchor:SetMovable(true)
	WLHUD_PLAYER.HP_Anchor:SetMouseEnabled(true)
	WLHUD_PLAYER.HP_Anchor:SetHandler( "OnMouseUp", function(self) WLHUD_PLAYER_HP_Anchor_MouseUp() end)

	WLHUD_PLAYER_MP_Anchor:SetHidden(false)
	WLHUD_PLAYER_MP_Anchor:SetMovable(true)
	WLHUD_PLAYER_MP_Anchor:SetMouseEnabled(true)
	WLHUD_PLAYER_MP_Anchor:SetHandler( "OnMouseUp", function(self) WLHUD_PLAYER_MP_Anchor_MouseUp() end)

	WLHUD_PLAYER.SP_Anchor:SetHidden(false)
	WLHUD_PLAYER.SP_Anchor:SetMovable(true)
	WLHUD_PLAYER.SP_Anchor:SetMouseEnabled(true)
	WLHUD_PLAYER.SP_Anchor:SetHandler( "OnMouseUp", function(self) WLHUD_PLAYER_SP_Anchor_MouseUp() end)

	WLHUD_PLAYER.Horse_Anchor:SetHidden(false)
	WLHUD_PLAYER.Horse_Anchor:SetMovable(true)
	WLHUD_PLAYER.Horse_Anchor:SetMouseEnabled(true)
	WLHUD_PLAYER.Horse_Anchor:SetHandler( "OnMouseUp", function(self) WLHUD_PLAYER_Horse_Anchor_MouseUp() end)

	-- if (WLHUD_SAVE.Enable_Player_CastBar == true) then
	-- 	WLHUD_PLAYER.Cast_Anchor:SetHidden(false)
	-- 	WLHUD_PLAYER.Cast_Anchor:SetMovable(true)
	-- 	WLHUD_PLAYER.Cast_Anchor:SetMouseEnabled(true)
	-- 	WLHUD_PLAYER.Cast_Anchor:SetHandler( "OnMouseUp", function(self) WLHUD_PLAYER.Cast_Anchor_MouseUp() end)
	-- end
	
	WLHUD_TARGET.Anchor:SetHidden(false)
	WLHUD_TARGET.Anchor:SetMovable(true)
	WLHUD_TARGET.Anchor:SetMouseEnabled(true)
	WLHUD_TARGET.Anchor:SetHandler( "OnMouseUp", function(self) WLHUD_TARGET_Anchor_MouseUp() end)

	WLHUD_TARGET.HP_Anchor:SetHidden(false)
	WLHUD_TARGET.HP_Anchor:SetMovable(true)
	WLHUD_TARGET.HP_Anchor:SetMouseEnabled(true)
	WLHUD_TARGET.HP_Anchor:SetHandler( "OnMouseUp", function(self) WLHUD_TARGET_HP_Anchor_MouseUp() end)

	-- WLHUD_TARGET.MP_Anchor:SetHidden(false)
	-- WLHUD_TARGET.MP_Anchor:SetMovable(true)
	-- WLHUD_TARGET.MP_Anchor:SetMouseEnabled(true)
	-- WLHUD_TARGET.MP_Anchor:SetHandler( "OnMouseUp", function(self) WLHUD_TARGET_MP_Anchor_MouseUp() end)

	-- WLHUD_TARGET.SP_Anchor:SetHidden(false)
	-- WLHUD_TARGET.SP_Anchor:SetMovable(true)
	-- WLHUD_TARGET.SP_Anchor:SetMouseEnabled(true)
	-- WLHUD_TARGET.SP_Anchor:SetHandler( "OnMouseUp", function(self) WLHUD_TARGET_SP_Anchor_MouseUp() end)
	
	-- WLHUD_PLAYER.Buff_MW:SetHidden(false)
	-- WLHUD_PLAYER.Buff_MW:SetMovable(true)
	-- WLHUD_PLAYER.Buff_MW:SetMouseEnabled(true)
	-- WLHUD_PLAYER.Buff_BG:SetHidden(false)
	-- WLHUD_PLAYER.Buff_MW_LBL:SetHidden(false)
	-- WLHUD_PLAYER.Buff_MW:SetHandler( "OnMouseUp", function(self) WLHUD_PLAYER_Buff_MW_MouseUp() end)
	
	-- WLHUD_PLAYER.DeBuff_MW:SetHidden(false)
	-- WLHUD_PLAYER.DeBuff_MW:SetMovable(true)
	-- WLHUD_PLAYER.DeBuff_MW:SetMouseEnabled(true)
	-- WLHUD_PLAYER.DeBuff_BG:SetHidden(false)
	-- WLHUD_PLAYER.DeBuff_MW_LBL:SetHidden(false)
	-- WLHUD_PLAYER.DeBuff_MW:SetHandler( "OnMouseUp", function(self) WLHUD_PLAYER_DeBuff_MW_MouseUp() end)
	
	-- WLHUD_TARGET.Buff_MW:SetHidden(false)
	-- WLHUD_TARGET.Buff_MW:SetMovable(true)
	-- WLHUD_TARGET.Buff_MW:SetMouseEnabled(true)
	-- WLHUD_TARGET.Buff_BG:SetHidden(false)
	-- WLHUD_TARGET.Buff_MW_LBL:SetHidden(false)
	-- WLHUD_TARGET.Buff_MW:SetHandler( "OnMouseUp", function(self) WLHUD_TARGET_Buff_MouseUp() end)
	
	-- WLHUD_TARGET.DeBuff_MW:SetHidden(false)
	-- WLHUD_TARGET.DeBuff_MW:SetMovable(true)
	-- WLHUD_TARGET.DeBuff_MW:SetMouseEnabled(true)
	-- WLHUD_TARGET.DeBuff_BG:SetHidden(false)
	-- WLHUD_TARGET.DeBuff_MW_LBL:SetHidden(false)
	-- WLHUD_TARGET.DeBuff_MW:SetHandler( "OnMouseUp", function(self) WLHUD_TARGET_DeBuff_MW_MouseUp() end)
	
	WLHUD_MESSAGE_MW:SetHidden(false)
	WLHUD_MESSAGE.LBL:SetHidden(false)
	WLHUD_MESSAGE_MW:SetMovable(true)
	WLHUD_MESSAGE_MW:SetMouseEnabled(true)
	WLHUD_MESSAGE_MW:SetHandler( "OnMouseUp", function(self) WLHUD_MESSAGE_MouseUp() end)
	
	-- WLHUD_TARGET_T.Anchor:SetHidden(false)
	-- WLHUD_TARGET_T.BG:SetHidden(false)
	-- WLHUD_TARGET_T.Anchor_Tex:SetHidden(false)
	-- WLHUD_TARGET_T.Anchor:SetMovable(true)
	-- WLHUD_TARGET_T.Anchor:SetMouseEnabled(true)
	-- WLHUD_TARGET_T.Anchor:SetHandler( "OnMouseUp", function(self) WLHUD_TARGET_T.MouseUp() end)
	
	WLHUD_TARGET.Execute_LBL:SetHidden(true)
	
	-- WLHUD_TARGET_Update()
end --WLHUD_Toggle_Settings()