--[[-----------------------------------------------------------
	WarLegend HUD HUD
	----------------------------------------------------------
	* A simple Addon to show your HUD in a better way.
	* 
	* Author : Lyeos Maouli - @lyeos
	* Website : www.warlegend.net
	*
	* 
	* Traduction FR: Sephivrine
	* German Transtale: Meinereiner
	* Special Thanks: @Wykkyd
  ]]----------------------------------------------------------

-- Create Global --
-- WLHUD = {}
WLHUD 			   = ZO_Object:Subclass()
WLHUD_ACE 		   = {}

WLHUD_VERSION	   = 1.03

WLHUD_CTRL_CREATED = false
WLHUD_SETTINGS     = 0
WLHUD_INSIEGE      = false
WLHUD_INCOMBAT     = false
WLHUD_ANIM_LOADED  = false
WLHUD_FIRSTLOAD    = false

WLHUD_GAMETIME	   = 0

WLHUD_MEM_USAGE	   = ZO_Object:Subclass()
WLHUD_MESSAGE 	   = ZO_Object:Subclass()
WLHUD_PLAYER  	   = ZO_Object:Subclass()
WLHUD_SIEGE 	   = ZO_Object:Subclass()
WLHUD_TARGET 	   = ZO_Object:Subclass()
WLHUD_TARGET_T 	   = ZO_Object:Subclass()
WLHUD_BUFFS 	   = ZO_Object:Subclass()
WLHUD_ANIM  	   = ZO_Object:Subclass()
WLHUD_TIMELINE 	   = ZO_Object:Subclass()
WLHUD_VISUALIZER   = ZO_Object:Subclass()
WLHUD_TARGETNAME   = ZO_Object:Subclass()

WLHUD_RIGHT_CLICK  = ZO_Object:Subclass()

WLHUD_PLAYER.HP_Modifier = 0
WLHUD_TARGET.HP_Modifier = 0

LibStub("AceTimer-3.0"):Embed(WLHUD_ACE)

-- Create Labels and List --
local function WLHUD_Chain( object )
	
	-- Setup the metatable
	local T = {}
	setmetatable( T, { __index = function( self, func )
		
		-- Know when to stop chaining
		if func == "__END" then	return object end
		
		-- Otherwise, add the method to the parent object
		return function( self, ... )
			assert( object[func], func .. " missing in object" )
			object[func]( object, ... )
			return self
		end
	end })
	
	-- Return the metatable
	return T
end

local function WLHUD_CreateControls()
	-- PLAYER --
	WLHUD_PLAYER:Create()
	-- WLHUD_PLAYER:Create_Buffs()
	-- WLHUD_PLAYER:Create_CastBar()
	WLHUD_PLAYER:Create_Shield()
	
	-- TARGET --
	WLHUD_TARGET:Create()
	-- WLHUD_TARGET:Create_Buffs()
	-- WLHUD_TARGET:Create_CastBar()
	WLHUD_TARGET:Create_Shield()
	
	-- TARGETTARGET --
	-- WLHUD_TARGET_T:Create()
	-- WLHUD_TARGET_T:Create_CastBar()
	-- WLHUD_TARGET_T:Create_Shield()

	-- SHAREDAREA --
	WLHUD_MESSAGE:Create()

	-- SIEGEBAR --
	WLHUD_SIEGE:Create()
	
	-- MemUsage --
	WLHUD_MEM_USAGE:Create()

	-- RightClick --
	WLHUD_RIGHT_CLICK:Create_RightClick()

	-- Controls_Created --
	WLHUD_CTRL_CREATED = true

	local WLHUD_CleanGarbage = WLHUD_ACE:ScheduleTimer(function() collectgarbage() end, 5)
end --WLHUD_CreateControls()

local function WLHUD_Power_Update(eventCode, unitTag, powerIndex, powerType, powerValue, powerMax, powerEffectiveMax)
	-- d(unitTag..": "..powerType)
	if (GetUnitName(unitTag) == GetUnitName("player")) then WLHUD_PLAYER:Update(eventCode, unitTag, powerIndex, powerType, powerValue, powerMax, powerEffectiveMax) end

	if (unitTag == "reticleover") then WLHUD_TARGET:Update(eventCode, unitTag, powerIndex, powerType, powerValue, powerMax, powerEffectiveMax) end
	
	-- if (unitTag == "reticleovertarget") then WLHUD_TARGET_T:Update(eventCode, unitTag, powerIndex, powerType, powerValue, powerMax, powerEffectiveMax) end
	
	if (unitTag == "controlledsiege") then
		WLHUD_INSIEGE = true
		WLHUD_PLAYER.SPB:SetHidden(true)
		WLHUD_PLAYER.MPB:SetHidden(true)
		WLHUD_PLAYER.MPB_BG:SetHidden(false)
		WLHUD_SIEGE.HPB:SetHidden(false)

		WLHUD_SIEGE:Update(eventCode, unitTag, powerIndex, powerType, powerValue, powerMax, powerEffectiveMax)
	end
end -- WLHUD_Power_Update()

local function WLHUD_CombatState(eventCode, inCombat ) WLHUD_INCOMBAT = inCombat end

local function WLHUD_ZoneChanged(eventCode)
	local unitTag = "player"
	WLHUD_Power_Update(eventCode, unitTag)
end

-- Slash Commands Handler --
local function WLHUD_commandHandler( text )
	if (text == "move") then
		local Check_SettingsMW = _G["WLHUD_SETTINGS_MW"]
		
		if (Check_SettingsMW == nil) then
			WLHUD_SETTINGS = 1
			SetGameCameraUIMode(true)
			WLHUD_InitializeSettings()
		else
			if (WLHUD_SETTINGS_MW:IsHidden() == true) then
				SetGameCameraUIMode(true)
				WLHUD_SETTINGS = 1
				WLHUD_Toggle_Settings()
			else
				WLHUD_SETTINGS = 1
				SetGameCameraUIMode(false)
			end
		end
			
	elseif (text == "reset") then
		WLHUD_Reset_All_Positions()
		
	else
		d ( "|cDC143CUnity HUD "..WLHUD_Commands..":|r\n"..
		"|cFFFFFF"..WLHUD_Commands1.."|r\n"..
		"|cCC6600     /WLHUD move |r: "..WLHUD_Commands2.."\n"..
		"|cCC6600     /WLHUD reset |r: "..WLHUD_Commands3.."\n"..
		"|cFFFFFF version "..WLHUD_VERSION
		)
	end
end --WLHUD_commandHandler( text )

-- Function Menu Opened
local function WLHUD_Event_menu_opened()
	local checkReticle = IsReticleHidden()
	local gamemenu = ZO_GameMenu_InGame:IsHidden()
	local worldmap = ZO_WorldMap:IsHidden()

	if _G["WLHUD_RIGHT_CLICK_BG_WLHUD"] ~= nil then _G["WLHUD_RIGHT_CLICK_BG_WLHUD"]:SetHidden(true) end
	
	if ( WLHUD_SAVE.Enable_Preview ~= true ) then
		if (WLHUD_SETTINGS == 0) then
			if not checkReticle then
				WLHUD_VISUALIZER["MW"]:SetHidden(false)
				WLHUD_MW:SetHidden(false)
				WLHUD_PLAYER.Anchor:SetHidden(false)
				-- WLHUD_PLAYER.Buff_MW:SetHidden(false)
				-- WLHUD_PLAYER.DeBuff_MW:SetHidden(false)
				-- WLHUD_TARGET.Buff_MW:SetHidden(false)
				-- WLHUD_TARGET.DeBuff_MW:SetHidden(false)
				WLHUD_MEM_USAGE.Anchor:SetHidden(false)

				if (WLHUD_RIGHT_CLICK["ZO_DisplayName_TOP"] ~= nil) then
					ZO_DisplayName:SetAnchor(TOPLEFT, GuiRoot, TOPLEFT, WLHUD_RIGHT_CLICK["ZO_DisplayName_LEFT"],WLHUD_RIGHT_CLICK["ZO_DisplayName_TOP"])
					ZO_DisplayName:SetHidden(true)
				end
				if not (WLHUD_RIGHT_CLICK["_BG_RightClick"]:IsHidden()) then
					WLHUD_RIGHT_CLICK["_BG_RightClick"]:SetHidden(true)
				end
			else
				WLHUD_VISUALIZER["MW"]:SetHidden(true)
				if worldmap then
					if gamemenu then
						WLHUD_MW:SetHidden(false)
						WLHUD_PLAYER.Anchor:SetHidden(false)
						-- WLHUD_PLAYER.Buff_MW:SetHidden(false)
						-- WLHUD_PLAYER.DeBuff_MW:SetHidden(false)
						-- WLHUD_TARGET.Buff_MW:SetHidden(false)
						-- WLHUD_TARGET.DeBuff_MW:SetHidden(false)
						WLHUD_MEM_USAGE.Anchor:SetHidden(false)
					else
						WLHUD_MW:SetHidden(true)
						WLHUD_PLAYER.Anchor:SetHidden(true)
						-- WLHUD_PLAYER.Buff_MW:SetHidden(true)
						-- WLHUD_PLAYER.DeBuff_MW:SetHidden(true)
						-- WLHUD_TARGET.Buff_MW:SetHidden(true)
						-- WLHUD_TARGET.DeBuff_MW:SetHidden(true)
						WLHUD_MEM_USAGE.Anchor:SetHidden(true)

						if (WLHUD_RIGHT_CLICK["ZO_DisplayName_TOP"] ~= nil) then
							ZO_DisplayName:SetAnchor(TOPLEFT, GuiRoot, TOPLEFT, WLHUD_RIGHT_CLICK["ZO_DisplayName_LEFT"],WLHUD_RIGHT_CLICK["ZO_DisplayName_TOP"])
							ZO_DisplayName:SetHidden(true)
						end
						if not (WLHUD_RIGHT_CLICK["_BG_RightClick"]:IsHidden()) then
							WLHUD_RIGHT_CLICK["_BG_RightClick"]:SetHidden(true)
						end
					end
				else
					WLHUD_MW:SetHidden(true)
					WLHUD_PLAYER.Anchor:SetHidden(true)
					-- WLHUD_PLAYER.Buff_MW:SetHidden(true)
					-- WLHUD_PLAYER.DeBuff_MW:SetHidden(true)
					-- WLHUD_TARGET.Buff_MW:SetHidden(true)
					-- WLHUD_TARGET.DeBuff_MW:SetHidden(true)
					WLHUD_MEM_USAGE.Anchor:SetHidden(true)

					if (WLHUD_RIGHT_CLICK["ZO_DisplayName_TOP"] ~= nil) then
						ZO_DisplayName:SetAnchor(TOPLEFT, GuiRoot, TOPLEFT, WLHUD_RIGHT_CLICK["ZO_DisplayName_LEFT"],WLHUD_RIGHT_CLICK["ZO_DisplayName_TOP"])
						ZO_DisplayName:SetHidden(true)
					end
					if not (WLHUD_RIGHT_CLICK["_BG_RightClick"]:IsHidden()) then
						WLHUD_RIGHT_CLICK["_BG_RightClick"]:SetHidden(true)
					end
				end


			end
		-- else
			-- SetGameCameraUIMode(true)
		end
	end
end --WLHUD_Event_menu_opened()

local function WLHUD_LoadAnimations()
	if (WLHUD_CTRL_CREATED == true) then
		if (WLHUD_ANIM_LOADED == false) then
		    WLHUD_animLHP, WLHUD_timelineLHP = CreateSimpleAnimation(ANIMATION_SCALE, WLHUD_PLAYER.LowHP_Icon)
			WLHUD_animLHP:SetScaleValues(0.95, 1.25)
			WLHUD_animLHP:SetDuration(500)
			WLHUD_timelineLHP:SetPlaybackType(ANIMATION_PLAYBACK_PING_PONG, LOOP_INDEFINITELY)
			WLHUD_timelineLHP:PlayFromStart()
			
		    WLHUD_animLMP, WLHUD_timelineLMP = CreateSimpleAnimation(ANIMATION_SCALE, WLHUD_PLAYER.LowMP_Icon)
			WLHUD_animLMP:SetScaleValues(0.95, 1.05)
			WLHUD_animLMP:SetDuration(500)
			WLHUD_timelineLMP:SetPlaybackType(ANIMATION_PLAYBACK_PING_PONG, LOOP_INDEFINITELY)
			WLHUD_timelineLMP:PlayFromStart()
			
		    WLHUD_animLSP, WLHUD_timelineLSP = CreateSimpleAnimation(ANIMATION_SCALE, WLHUD_PLAYER.LowSP_Icon)
			WLHUD_animLSP:SetScaleValues(0.95, 1.05)
			WLHUD_animLSP:SetDuration(500)
			WLHUD_timelineLSP:SetPlaybackType(ANIMATION_PLAYBACK_PING_PONG, LOOP_INDEFINITELY)
			WLHUD_timelineLSP:PlayFromStart()

			WLHUD_animLExec, WLHUD_timelineLExec = CreateSimpleAnimation(ANIMATION_SCALE, WLHUD_TARGET.Execute)
			WLHUD_animLExec:SetScaleValues(0.95, 1.05)
			WLHUD_animLExec:SetDuration(250)
			WLHUD_timelineLExec:SetPlaybackType(ANIMATION_PLAYBACK_PING_PONG, LOOP_INDEFINITELY)
			WLHUD_timelineLExec:PlayFromStart()

			WLHUD_ANIM_LOADED = true
		elseif (WLHUD_SAVE.Enable_Player_Alets == true) and (WLHUD_ANIM_LOADED == false) then
			WLHUD_timelineLHP:PlayFromStart()
			WLHUD_timelineLMP:PlayFromStart()
			WLHUD_timelineLSP:PlayFromStart()
			WLHUD_timelineLExec:PlayFromStart()
		end
	end
end -- WLHUD_LoadAnimations()

local function WLHUD_InitializeLanguage()
	WLHUD_LanguageOption_Warn = "Changing this option will Reload your UI!\n".. "Changer cette option rechargera l'interface!"

	if (WLHUD_SAVE.Language == "English") then
		WLHUD_Translate_English()
	elseif (WLHUD_SAVE.Language == "Français") then
		WLHUD_Translate_French()
	elseif (WLHUD_SAVE.Language == "German") then
		WLHUD_Translate_German()
	else
		WLHUD_SAVE.Language = "English"
		WLHUD_InitializeLanguague()
	end
end -- WLHUD_InitializeLanguage()

local function WLHUD_Mounted(eventCode, isMounted)
	if (isMounted == true) then
		WLHUD_PLAYER.Horse_SPB:SetHidden(false)
		WLHUD_PLAYER:Update()
	else
		WLHUD_PLAYER.Horse_SPB:SetHidden(true)
	end
end -- WLHUD_Mounted()

-- local function WLHUD_MouseDown(eventCode, button)
-- 	if (button == 2) and IsShiftKeyDown() then
-- 		SetGameCameraUIMode(true)
-- 	end
-- end

local function WLHUD_ATTRIBUTE_VISUAL_ADDED( eventCode, unitTag, unitAttributeVisual, statType, attributeType, powerType, value, maxValue )
	if (unitAttributeVisual == 5) then
		WLHUD_NewDamageShield( eventCode, unitTag, unitAttributeVisual, statType, attributeType, powerType, value, maxValue )
	else
		WLHUD_Visualizer_Added( eventCode, unitTag, unitAttributeVisual, statType, attributeType, powerType, value, maxValue )
		-- d("WLHUD_ATTRIBUTE_VISUAL_ADDED")
	end
end

local function WLHUD_ATTRIBUTE_VISUAL_END( eventCode, unitTag, unitAttributeVisual, statType, attributeType, powerType, value, maxValue )
	if (unitAttributeVisual == 5) then
		WLHUD_EndDamageShield( eventCode, unitTag, unitAttributeVisual, statType, attributeType, powerType, value, maxValue )
	else
		WLHUD_Visualizer_Removed( eventCode, unitTag, unitAttributeVisual, statType, attributeType, powerType, value, maxValue )
		-- d("WLHUD_ATTRIBUTE_VISUAL_END")
	end
end

local function WLHUD_ATTRIBUTE_VISUAL_UPDATE( eventCode, unitTag, unitAttributeVisual, statType, attributeType, powerType, value, maxValue )
	if (unitAttributeVisual == 5) then
		WLHUD_UpdateDamageShield( eventCode, unitTag, unitAttributeVisual, statType, attributeType, powerType, value, maxValue )
	else
		-- d("WLHUD_ATTRIBUTE_VISUAL_UPDATE")
		WLHUD_Visualizer_Added( eventCode, unitTag, unitAttributeVisual, statType, attributeType, powerType, value, maxValue )
	end
end

local function WLHUD_TargetChanged()
	local name 		  = WLHUD_TARGETNAME[GetUnitName("reticleover")]
	local armor_timer = (GetGameTimeMilliseconds() < (WLHUD_GAMETIME + 15000))

	if (name ~= nil) then
		if name and armor_timer then
			WLHUD_VISUALIZER["reticleover831"]:SetHidden(false)
			WLHUD_TIMELINE["reticleover831"]:PlayFromStart()
			-- d("WLHUD_TargetChanged")
			-- d("WLHUD_GAMETIME: "..WLHUD_GAMETIME)
			-- d("Actual Time: "..(GetGameTimeMilliseconds() + 15000))
		end
	else
		WLHUD_VISUALIZER["reticleover381"]:SetHidden(true)
		WLHUD_TIMELINE["reticleover381"]:Stop()
		WLHUD_VISUALIZER["reticleover731"]:SetHidden(true)
		WLHUD_TIMELINE["reticleover731"]:Stop()
		WLHUD_VISUALIZER["reticleover481"]:SetHidden(true)
		WLHUD_TIMELINE["reticleover481"]:Stop()
		WLHUD_VISUALIZER["reticleover831"]:SetHidden(true)
		WLHUD_TIMELINE["reticleover831"]:Stop()
	end
	
	WLHUD_TARGET:Update()
end

local function WLHUD_InitializeMain()
	WLHUD_InitializeLanguage()
	ZO_PlayerAttribute:SetHidden(true)
	
	-- Create Main Window
	WLHUD_MW = WLHUD_Chain(WINDOW_MANAGER:CreateTopLevelWindow("WarLegendHUD_MW"))
		:SetDimensions(450,75)
		:SetAnchor(BOTTOM,GuiRoot,BOTTOM, 0,-110)
	.__END
	
	WLHUD_MW_BG = WLHUD_Chain(WINDOW_MANAGER:CreateControl("WLHUD_MW_BG", WLHUD_MW, CT_BACKDROP))
		:SetCenterColor(0.1,0.1,0.1,1)
		:SetEdgeColor(1,1,1,0)
		:SetEdgeTexture("", 8, 1, 1)
		:SetDrawLayer(1)
		:SetAnchorFill(WLHUD_MW)
		:SetHidden(true)
	.__END
	
	WLHUD_CreateControls()
	
	EVENT_MANAGER:RegisterForEvent("WarLegendHUD", EVENT_RETICLE_HIDDEN_UPDATE, WLHUD_Event_menu_opened) -- MENU OPENED
	EVENT_MANAGER:RegisterForEvent("WarLegendHUD", EVENT_POWER_UPDATE, WLHUD_Power_Update) -- POWER EVENT
	EVENT_MANAGER:RegisterForEvent("WarLegendHUD", EVENT_RETICLE_TARGET_CHANGED, WLHUD_TargetChanged) -- RETICLE TARGETTARGET
	EVENT_MANAGER:RegisterForEvent("WarLegendHUD", EVENT_UNIT_ATTRIBUTE_VISUAL_ADDED , WLHUD_ATTRIBUTE_VISUAL_ADDED) -- ADDED DAMAGE SHIELD
	EVENT_MANAGER:RegisterForEvent("WarLegendHUD", EVENT_UNIT_ATTRIBUTE_VISUAL_REMOVED , WLHUD_ATTRIBUTE_VISUAL_END) -- REMOVED DAMAGE SHIELD
	EVENT_MANAGER:RegisterForEvent("WarLegendHUD", EVENT_UNIT_ATTRIBUTE_VISUAL_UPDATED , WLHUD_ATTRIBUTE_VISUAL_UPDATE) -- UPDATE DAMAGE SHIELD
	EVENT_MANAGER:RegisterForEvent("WarLegendHUD", EVENT_UNIT_DEATH_STATE_CHANGED, function(...) WLHUD_PLAYER:Update(...) end) -- DEATH STATE CHANGED
	EVENT_MANAGER:RegisterForEvent("WarLegendHUD", EVENT_MOUNTED_STATE_CHANGED, WLHUD_Mounted) -- MOUNT STATE CHANGED
	EVENT_MANAGER:RegisterForEvent("WarLegendHUD", EVENT_BEGIN_SIEGE_CONTROL, WLHUD_Begin_Siege) -- BEGIN SIEGE CONTROL
	EVENT_MANAGER:RegisterForEvent("WarLegendHUD", EVENT_END_SIEGE_CONTROL, WLHUD_End_Siege) -- END SIEGE CONTROL
	EVENT_MANAGER:RegisterForEvent("WarLegendHUD", EVENT_PLAYER_COMBAT_STATE , WLHUD_CombatState) -- COMBAT STATE
	EVENT_MANAGER:RegisterForEvent("WarLegendHUD", EVENT_ZONE_UPDATE , WLHUD_ZoneChanged) -- ZONE UPDATE
	EVENT_MANAGER:RegisterForEvent("WarLegendHUD", EVENT_ZONE_CHANGED , WLHUD_ZoneChanged) -- ZONE CHANGED
	-- EVENT_MANAGER:RegisterForEvent("WarLegendHUD", EVENT_GLOBAL_MOUSE_DOWN , WLHUD_MouseDown) -- GLOBAL MOUSEDOWN
end --function WLHUD_InitializeMain()

  --In your handler:
local function OnAddOnLoaded(eventCode, addOnName)
	
	if(addOnName == "WarLegendHUD") then
		WLHUD_InitializeMain()
		WLHUD_InitializeMenu()
		WLHUD_LoadAnimations()
		WLHUD_Visualizer_CreateAnim()
		WLHUD_Debug()

		local WLHUD_LoadTimer = WLHUD_ACE:ScheduleTimer(function() WLHUD_FIRSTLOAD = true WLHUD_Loaded() end, 0.5)
	end

	Default	= {
			["Global_X"] = 0,
			["Global_Y"] = 0,
			["Enable_P_Sticky"] = false,
			["Player_Anchor_X"] = 595,
			["Player_Anchor_Y"] = 938,
			["PlayerHP_Anchor_X"] = 480,
			["PlayerHP_Anchor_Y"] = 936,
			["PlayerHP_Height"] = 0,
			["PlayerHP_Texture"] = true,
			["PlayerMP_Anchor_X"] = 480,
			["PlayerMP_Anchor_Y"] = 961,
			["PlayerMP_Height"] = 0,
			["PlayerMP_Texture"] = true,
			["MPBarDir"] = "Right to Left",
			["PlayerSP_Anchor_X"] = 480,
			["PlayerSP_Anchor_Y"] = 986,
			["Horse_Anchor_X"] = 460,
			["Horse_Anchor_Y"] = 1006,
			["PlayerSP_Height"] = 0,
			["PlayerSP_Texture"] = true,
			["PlayerCast_Anchor_X"] = 575,
			["PlayerCast_Anchor_Y"] = 910,
			["Target_Anchor_X"] = 940,
			["Target_Anchor_Y"] = 860,
			["TargetHP_Anchor_X"] = 1300,
			["TargetHP_Anchor_Y"] = 936,
			-- ["TargetHP_Height"] = 0,
			-- ["TargetMP_Anchor_X"] = 1300,
			-- ["TargetMP_Anchor_Y"] = 961,
			-- ["TargetMP_Height"] = 0,
			-- ["TargetSP_Anchor_X"] = 1300,
			-- ["TargetSP_Anchor_Y"] = 986,
			-- ["TargetSP_Height"] = 0,
			["TargetTarget_Anchor_X"] = 1245,
			["TargetTarget_Anchor_Y"] = 750,
			["TargetHP_Texture"] = true,
			-- ["PlayerBuffs_X"] = 635,
			-- ["PlayerBuffs_Y"] = 845,
			-- ["PlayerDEBuffs_X"] = 635,
			-- ["PlayerDEBuffs_Y"] = 780,
			-- ["TargetBuffs_X"] = 1305,
			-- ["TargetBuffs_Y"] = 970,
			-- ["TargetDEBuffs_X"] = 1305,
			-- ["TargetDEBuffs_Y"] = 905,
			["SharedArea_X"] = 860,
			["SharedArea_Y"] = 200,
			["Player_Scale"] = 0.75,
			["Target_Scale"] = 0.75,
			["TargetTarget_Scale"] = 0.75,
			-- ["PBuff_R"] = 1,
			-- ["PBuff_G"] = 1,
			-- ["PBuff_B"] = 1,
			-- ["PDEBuff_R"] = 1,
			-- ["PDEBuff_G"] = 1,
			-- ["PDEBuff_B"] = 1,
			-- ["TBuff_R"] = 1,
			-- ["TBuff_G"] = 1,
			-- ["TBuff_B"] = 1,
			-- ["TDEBuff_R"] = 1,
			-- ["TDEBuff_G"] = 1,
			-- ["TDEBuff_B"] = 1,
			["PCastS_R"] = 0.553,
			["PCastS_G"] = 0.251,
			["PCastS_B"] = 0.141,
			["PCastE_R"] = 0.682,
			["PCastE_G"] = 0.537,
			["PCastE_B"] = 0.392,
			["Enable_Player_HP_Text"] = true,
			["Enable_Player_MP_Text"] = true,
			["Enable_Player_SP_Text"] = true,
			-- ["Enable_Player_CastBar"] = true,
			-- ["Enable_Player_Buffs"] = true,
			-- ["Enable_Player_Buffs_Tm"] = true,
			-- ["Enable_Player_DEBuffs"] = true,
			-- ["Enable_Player_DEBuffs_Tm"] = true,
			["Enable_Player_HP_Perc"] = true,
			["Enable_Player_MP_Perc"] = true,
			["Enable_Player_SP_Perc"] = true,
			["Player_HP_InBar"] = false,
			["Player_SP_InBar"] = false,
			["Player_MP_InBar"] = false,
			["Enable_Target"] = true,
			["Target_HPBar_Width"] = 350,
			-- ["Target_MPBar_Width"] = 350,
			-- ["Target_SPBar_Width"] = 350,
			["TargetHP_Height"] = 0,
			-- ["TargetMP_Height"] = 0,
			-- ["TargetSP_Height"] = 0,
			["Enable_Target_Exec"] = true,
			["Target_Exec_Tresh"] = 20,
			["Target_HP_InBar"] = true,
			-- ["Target_SP_InBar"] = true,
			-- ["Target_MP_InBar"] = true,
			-- ["Enable_Target_CastBar"] = true,
			["Enable_Target_HP_Perc"] = true,
			-- ["Enable_Target_MP_Perc"] = true,
			-- ["Enable_Target_SP_Perc"] = true,
			-- ["Enable_Target_Buffs"] = true,
			-- ["Enable_Target_Buffs_Tm"] = true,
			-- ["Enable_Target_DEBuffs"] = true,
			-- ["Enable_Target_DEBuffs_Tm"] = true,
			["Enable_Target_T"] = true,
			-- ["Enable_Target_T_CastBar"] = true,
			["Enable_Target_T_HP_Perc"] = true,
			-- ["Enable_Target_T_MP_Perc"] = true,
			-- ["Enable_Target_T_SP_Perc"] = true,
			["Language"] = "English",
			["Lock_All_Frames"] = true,
			["Enable_MemUsage"] = false,
			["Enable_Preview"] = false,
			["Target_Perc_X"] = 220,
			["TargetT_Perc_X"] = 100,
			["Target_LBL_Width"] = 350,
			["Player_FadeOut"] = 0.5,
			["Target_FadeOut"] = 0.5,
			-- ["PBuff_Scale"] = 1,
			-- ["PDEBuff_Scale"] = 1,
			-- ["TBuff_Scale"] = 1,
			-- ["TDEBuff_Scale"] = 1,
			["Bars_Font"] = "ZoFontAlert",
			["Bars_Font_Size"] = 1,
			-- ["Player_PermaBuffs"] = true,
			-- ["Target_PermaBuffs"] = true,
			["Player_MaxStat"] = false,
			["Target_MaxStat"] = false,
			["Enalbe_Target_Class"] = false,
			-- ["PBuff_BG_R"] = 0.13,
			-- ["PBuff_BG_G"] = 0.8,
			-- ["PBuff_BG_B"] = 0.13,
			-- ["PDEBuff_BG_R"] = 0.8,
			-- ["PDEBuff_BG_G"] = 0.13,
			-- ["PDEBuff_BG_B"] = 0.13,
			-- ["TBuff_BG_R"] = 0.13,
			-- ["TBuff_BG_G"] = 0.8,
			-- ["TBuff_BG_B"] = 0.13,
			-- ["TDEBuff_BG_R"] = 0.8,
			-- ["TDEBuff_BG_G"] = 0.13,
			-- ["TDEBuff_BG_B"] = 0.13,
			["Player_HP_Alert"] = true,
			["Player_HP_Enable"] = true,
			["Player_HP_Tresh"] = 30,
			["Player_MP_Alert"] = true,
			["Player_MP_Enable"] = true,
			["Player_MP_Tresh"] = 30,
			["Player_SP_Alert"] = true,
			["Player_SP_Enable"] = true,
			["Player_SP_Tresh"] = 30,
			["Player_HPBar_Width"] = 450,
			["Player_MPBar_Width"] = 450,
			["Player_SPBar_Width"] = 450,
			-- ["Player_CatBar_Width"] = 450,
			["Player_HPPerc_X"] = 220,
			["Player_MPPerc_X"] = 220,
			["Player_SPPerc_X"] = 220,
			["Def_ZOS_Target"] = false,
			["Exec_Type"] = 1,
			["Exec_Size"] = 64,
			["FriendC"] = {44/255, 117/255, 1},
			["GuildC"] = {85/255, 1, 85/255},
			}

	-- Load saved variables
	WLHUD_SAVE = ZO_SavedVars:NewAccountWide( "WarLegendHUDSave", 1, nil, Default, nil )
end -- OnAddOnLoaded()

--In your initialize:
EVENT_MANAGER:RegisterForEvent("WarLegendHUD", EVENT_ADD_ON_LOADED, OnAddOnLoaded)


function WLHUD_Reset_All_Positions()
	WLHUD_SAVE.Enable_Preview = false

	WLHUD_SAVE.Global_X = 0
	WLHUD_SAVE.Global_Y = 0
	WLHUD_SAVE.Player_Anchor_X = 595
	WLHUD_SAVE.Player_Anchor_Y = 938
	WLHUD_SAVE.PlayerHP_Anchor_X = 480
	WLHUD_SAVE.PlayerHP_Anchor_Y = 936
	WLHUD_SAVE.PlayerHP_Height = 0
	WLHUD_SAVE.PlayerMP_Anchor_X = 480
	WLHUD_SAVE.PlayerMP_Anchor_Y = 961
	WLHUD_SAVE.PlayerMP_Height = 0
	WLHUD_SAVE.PlayerSP_Anchor_X = 480
	WLHUD_SAVE.PlayerSP_Anchor_Y = 986
	WLHUD_SAVE.PlayerSP_Height = 0
	WLHUD_SAVE.Horse_Anchor_X = 460
	WLHUD_SAVE.Horse_Anchor_Y = 1006
	WLHUD_SAVE.PlayerCast_Anchor_X = 575
	WLHUD_SAVE.PlayerCast_Anchor_Y = 910
	WLHUD_SAVE.Target_Anchor_X = 940
	WLHUD_SAVE.Target_Anchor_Y = 860
	WLHUD_SAVE.TargetHP_Anchor_X = 1300
	WLHUD_SAVE.TargetHP_Anchor_Y = 936
	-- WLHUD_SAVE.TargetHP_Height = 0
	-- WLHUD_SAVE.TargetMP_Anchor_X = 1300
	-- WLHUD_SAVE.TargetMP_Anchor_Y = 961
	-- WLHUD_SAVE.TargetMP_Height = 0
	-- WLHUD_SAVE.TargetSP_Anchor_X = 1300
	-- WLHUD_SAVE.TargetSP_Anchor_Y = 986
	-- WLHUD_SAVE.TargetSP_Height = 0
	-- WLHUD_SAVE.TargetTarget_Anchor_X = 1245
	-- WLHUD_SAVE.TargetTarget_Anchor_Y = 750
	-- WLHUD_SAVE.PlayerBuffs_X = 635
	-- WLHUD_SAVE.PlayerBuffs_Y = 845
	-- WLHUD_SAVE.PlayerDEBuffs_X = 635
	-- WLHUD_SAVE.PlayerDEBuffs_Y = 780
	-- WLHUD_SAVE.TargetBuffs_X = 1305
	-- WLHUD_SAVE.TargetBuffs_Y = 970
	-- WLHUD_SAVE.TargetDEBuffs_X = 1305
	-- WLHUD_SAVE.TargetDEBuffs_Y = 905
	WLHUD_SAVE.SharedArea_X = 860
	WLHUD_SAVE.SharedArea_Y = 200
	
	ReloadUI()
	
	d("|cDC143C"..WLHUD_BackToDefaultPos)
end -- WLHUD_Reset_All_Positions()

--[[----------------------------------------------------------
 * Slash Commands----------------- KEEP AT END OF THE LUA
  ]]----------------------------------------------------------
	SLASH_COMMANDS["/wlh"] = WLHUD_commandHandler
