local LAM = LibStub("LibAddonMenu-1.0")
local WLHUD_Language = {"English", "Français", "German"}--, "Korean"}
local WLHUD_Fonts = {"ZoFontAlert",
					"ZoFontBookNote",
					"ZoFontBookPaper",
					"ZoFontBossName",
					"ZoFontChat",
					"ZoFontConversationName",
					"ZoFontConversationOpt",
					"ZoFontConversationQuestReward",
					"ZoFontGame",
					"ZoFontGameBold",
					"ZoFontGameLarge",
					"ZoFontGameLargeBold",
					"ZoFontHeader",
					"ZoFontHeader2",
					"ZoFontTooltipTitle",
					"ZoFontWindowSubtitle",
					}

function WLHUD_Menu_Infos()
	LAM:AddHeader(WLHUD_Menu, "WLHUD_Menu_Header_Infos", "|cF0C300"..WLHUD_CurrentVersion..":|r "..WLHUD_VERSION)
	LAM:AddDropdown(WLHUD_Menu, "WLHUD_Language", WLHUD_LanguageOpt, WLHUD_LanguageOpt_LBL, WLHUD_Language,
		function() return WLHUD_SAVE.Language end,
		function(WLHUD_Language)
			WLHUD_SAVE.Language = WLHUD_Language
			ReloadUI()
		end,
		true, WLHUD_LanguageOpt_Warn)

	LAM:AddCheckbox(WLHUD_Menu, "WLHUD_Enable_Preview", WLHUD_PreviewOpt, WLHUD_PreviewOpt_LBL,
		function() return WLHUD_SAVE.Enable_Preview end, 
		function(val)
			WLHUD_SAVE.Enable_Preview = val
			
			if (val == false) then
				WLHUD_TARGET.Anchor:SetHidden(true)
				-- WLHUD_TARGET_T.Anchor:SetHidden(true)
				WLHUD_PLAYER.Horse_SPB:SetHidden(true)

				-- WLHUD_PreviewBuff_MW:SetHidden(true)
				-- WLHUD_PreviewDEBuff_MW:SetHidden(true)
				-- WLHUD_T_PreviewBuff_MW:SetHidden(true)
				-- WLHUD_T_PreviewDEBuff_MW:SetHidden(true)

				-- WLHUD_PBuff_PreviewBG:SetHidden(true)
				-- WLHUD_PDEBuff_PreviewBG:SetHidden(true)
				-- WLHUD_TBuff_PreviewBG:SetHidden(true)
				-- WLHUD_TDEBuff_PreviewBG:SetHidden(true)
			else
				WLHUD_PLAYER.Anchor:SetHidden(false)
				WLHUD_PLAYER.Horse_SPB:SetHidden(false)
				WLHUD_TARGET.Anchor:SetHidden(false)
				-- WLHUD_TARGET_T.Anchor:SetHidden(false)

				-- WLHUD_PreviewBuff_MW:SetHidden(false)
				-- WLHUD_PreviewDEBuff_MW:SetHidden(false)
				-- WLHUD_T_PreviewBuff_MW:SetHidden(false)
				-- WLHUD_T_PreviewDEBuff_MW:SetHidden(false)

				-- WLHUD_PBuff_PreviewBG:SetHidden(false)
				-- WLHUD_PDEBuff_PreviewBG:SetHidden(false)
				-- WLHUD_TBuff_PreviewBG:SetHidden(false)
				-- WLHUD_TDEBuff_PreviewBG:SetHidden(false)
			end
		end)
	
	LAM:AddCheckbox(WLHUD_Menu, "WLHUD_Lock_All_Frames", WLHUD_LockOpt, WLHUD_LockOpt_LBL,
		function() return WLHUD_SAVE.Lock_All_Frames end, 
		function(val)
			WLHUD_SAVE.Lock_All_Frames = val

			if (val == false) then
				WLHUD_Check_Preview = WLHUD_SAVE.Enable_Preview
				if (WLHUD_Check_Preview == false) then
					WLHUD_SAVE.Enable_Preview = true
				end

				local Check_SettingsMW = _G["WLHUD_SETTINGS_MW"]
				if (Check_SettingsMW == nil) then
					SetGameCameraUIMode(true)
					WLHUD_SETTINGS = 1
					SetGameCameraUIMode(true)
					WLHUD_InitializeSettings()
				else
					if (WLHUD_SETTINGS_MW:IsHidden() == true) then
						SetGameCameraUIMode(true)
						WLHUD_SETTINGS = 1
						WLHUD_Toggle_Settings()
					else
						WLHUD_SETTINGS = 1
						SetGameCameraUIMode(false)
					end
				end
			else
				if (WLHUD_Check_Preview ~= true) then WLHUD_SAVE.Enable_Preview = false end
				WLHUD_SETTINGS_MWClose()
				SetGameCameraUIMode(true)
			end
		end)

	LAM:AddCheckbox(WLHUD_Menu, "WLHUD_Enable_MemUsage", WLHUD_MemOpt, WLHUD_MemOpt_LBL,
		function() return WLHUD_SAVE.Enable_MemUsage end, 
		function(val) WLHUD_SAVE.Enable_MemUsage = val end)

	LAM:AddDropdown(WLHUD_Menu, "WLHUD_BarFont", WLHUD_BarFontOpt, WLHUD_BarFontOpt_LBL, WLHUD_Fonts,
		function() return WLHUD_SAVE.Bars_Font end,
		function(font)
			WLHUD_SAVE.Bars_Font = font
			WLHUD_PLAYER.Anchor:SetHidden(false)
			WLHUD_PLAYER.HPBT:SetFont(WLHUD_SAVE.Bars_Font)
			WLHUD_PLAYER.HPPerc:SetFont(WLHUD_SAVE.Bars_Font)
			WLHUD_PLAYER.MPBT:SetFont(WLHUD_SAVE.Bars_Font)
			WLHUD_PLAYER.MPPerc:SetFont(WLHUD_SAVE.Bars_Font)
			WLHUD_PLAYER.SPBT:SetFont(WLHUD_SAVE.Bars_Font)
			WLHUD_PLAYER.SPPerc:SetFont(WLHUD_SAVE.Bars_Font)

			WLHUD_TARGET.HPBT:SetFont(WLHUD_SAVE.Bars_Font)
			WLHUD_TARGET.HPPerc:SetFont(WLHUD_SAVE.Bars_Font)
			-- WLHUD_TARGET.MPBT:SetFont(WLHUD_SAVE.Bars_Font)
			-- WLHUD_TARGET.MPPerc:SetFont(WLHUD_SAVE.Bars_Font)
			-- WLHUD_TARGET.SPBT:SetFont(WLHUD_SAVE.Bars_Font)
			-- WLHUD_TARGET.SPPerc:SetFont(WLHUD_SAVE.Bars_Font)
			WLHUD_TARGET.LBL:SetFont(WLHUD_SAVE.Bars_Font)
			WLHUD_TARGET.Class:SetFont(WLHUD_SAVE.Bars_Font)
			WLHUD_TARGET.LVL:SetFont(WLHUD_SAVE.Bars_Font)

			-- WLHUD_TARGET_T.HPBT:SetFont(WLHUD_SAVE.Bars_Font)
			-- WLHUD_TARGET_T.HPPerc:SetFont(WLHUD_SAVE.Bars_Font)
			-- WLHUD_TARGET_T.MPBT:SetFont(WLHUD_SAVE.Bars_Font)
			-- WLHUD_TARGET_T.MPPerc:SetFont(WLHUD_SAVE.Bars_Font)
			-- WLHUD_TARGET_T.SPBT:SetFont(WLHUD_SAVE.Bars_Font)
			-- WLHUD_TARGET_T.SPPerc:SetFont(WLHUD_SAVE.Bars_Font)
			-- WLHUD_TARGET_T.LBL:SetFont(WLHUD_SAVE.Bars_Font)
		end)

	LAM:AddSlider(WLHUD_Menu, "WLHUD_TexttScale", WLHUD_TexttSacle_Opt, WLHUD_TexttSacle_Opt_LBL, 75, 120, 1,
			function() return WLHUD_SAVE.Bars_Font_Size * 100 end,
			function(value)
				WLHUD_SAVE.Bars_Font_Size = value / 100

				WLHUD_PLAYER.HPBT:SetScale(WLHUD_SAVE.Bars_Font_Size)
				-- WLHUD_PLAYER.MPBT:SetScale(WLHUD_SAVE.Bars_Font_Size)
				-- WLHUD_PLAYER.SPBT:SetScale(WLHUD_SAVE.Bars_Font_Size)
				-- WLHUD_PLAYER.HPPerc:SetScale(WLHUD_SAVE.Bars_Font_Size)
				-- WLHUD_PLAYER.MPPerc:SetScale(WLHUD_SAVE.Bars_Font_Size)
				-- WLHUD_PLAYER.SPPerc:SetScale(WLHUD_SAVE.Bars_Font_Size)
				
				WLHUD_TARGET.LBL:SetScale(WLHUD_SAVE.Bars_Font_Size)
				WLHUD_TARGET.Class:SetScale(WLHUD_SAVE.Bars_Font_Size)
				WLHUD_TARGET.LVL:SetScale(WLHUD_SAVE.Bars_Font_Size)
				WLHUD_TARGET.HPPerc:SetScale(WLHUD_SAVE.Bars_Font_Size)
				-- WLHUD_TARGET.MPPerc:SetScale(WLHUD_SAVE.Bars_Font_Size)
				-- WLHUD_TARGET.SPPerc:SetScale(WLHUD_SAVE.Bars_Font_Size)
				WLHUD_TARGET.HPBT:SetScale(WLHUD_SAVE.Bars_Font_Size)
				-- WLHUD_TARGET.MPBT:SetScale(WLHUD_SAVE.Bars_Font_Size)
				-- WLHUD_TARGET.SPBT:SetScale(WLHUD_SAVE.Bars_Font_Size)
				-- WLHUD_TARGET.CastLBL:SetScale(WLHUD_SAVE.Bars_Font_Size)
				-- WLHUD_TARGET.CastReact:SetScale(WLHUD_SAVE.Bars_Font_Size)

				-- WLHUD_TARGET_T.LBL:SetScale(WLHUD_SAVE.Bars_Font_Size)
				-- WLHUD_TARGET_T.HPBT:SetScale(WLHUD_SAVE.Bars_Font_Size)
				-- WLHUD_TARGET_T.HPPerc:SetScale(WLHUD_SAVE.Bars_Font_Size)
				-- WLHUD_TARGET_T.MPPerc:SetScale(WLHUD_SAVE.Bars_Font_Size)
				-- WLHUD_TARGET_T.SPPerc:SetScale(WLHUD_SAVE.Bars_Font_Size)
				-- WLHUD_TARGET_T.MPBT:SetScale(WLHUD_SAVE.Bars_Font_Size)
				-- WLHUD_TARGET_T.SPBT:SetScale(WLHUD_SAVE.Bars_Font_Size)
				-- WLHUD_TARGET_T.CastLBL:SetScale(WLHUD_SAVE.Bars_Font_Size)
				-- WLHUD_TARGET_T.CastReact:SetScale(WLHUD_SAVE.Bars_Font_Size)
			end)

	LAM:AddSlider(WLHUD_Menu, "WLHUD_GLOBAL_X", WLHUD_GLOBAL_X_Opt, WLHUD_GLOBAL_X_Opt_LBL, -100, 100, 1,
			function() return WLHUD_SAVE.Global_X end,
			function(value)
				WLHUD_SAVE.Global_X = value

				WLHUD_MESSAGE:SetAnchor(TOPLEFT, GuiRoot, TOPLEFT, WLHUD_SAVE.Global_X + WLHUD_SAVE.SharedArea_X,WLHUD_SAVE.Global_Y + WLHUD_SAVE.SharedArea_Y)
				WLHUD_PLAYER.HP_Anchor:SetAnchor(TOPLEFT, GuiRoot, TOPLEFT, WLHUD_SAVE.Global_X + WLHUD_SAVE.PlayerHP_Anchor_X,WLHUD_SAVE.Global_Y + WLHUD_SAVE.PlayerHP_Anchor_Y)
				WLHUD_PLAYER_MP_Anchor:SetAnchor(TOPLEFT, GuiRoot, TOPLEFT, WLHUD_SAVE.Global_X + WLHUD_SAVE.PlayerMP_Anchor_X,WLHUD_SAVE.Global_Y + WLHUD_SAVE.PlayerMP_Anchor_Y)
				WLHUD_PLAYER.SP_Anchor:SetAnchor(TOPLEFT, GuiRoot, TOPLEFT, WLHUD_SAVE.Global_X + WLHUD_SAVE.PlayerSP_Anchor_X,WLHUD_SAVE.Global_Y + WLHUD_SAVE.PlayerSP_Anchor_Y)
				-- WLHUD_PLAYER.Buff_MW:SetAnchor(TOPLEFT,GuiRoot,TOPLEFT, WLHUD_SAVE.Global_X + WLHUD_SAVE.PlayerBuffs_X,WLHUD_SAVE.Global_Y + WLHUD_SAVE.PlayerBuffs_Y)
				-- WLHUD_PLAYER.DeBuff_MW:SetAnchor(TOPLEFT,GuiRoot,TOPLEFT, WLHUD_SAVE.Global_X + WLHUD_SAVE.PlayerDEBuffs_X,WLHUD_SAVE.Global_Y + WLHUD_SAVE.PlayerDEBuffs_Y)
				-- WLHUD_PreviewBuff_MW:SetAnchor(TOPLEFT,GuiRoot,TOPLEFT, WLHUD_SAVE.Global_X + WLHUD_SAVE.PlayerBuffs_X,WLHUD_SAVE.Global_Y + WLHUD_SAVE.PlayerBuffs_Y)
				-- WLHUD_PreviewDEBuff_MW:SetAnchor(TOPLEFT,GuiRoot,TOPLEFT, WLHUD_SAVE.Global_X + WLHUD_SAVE.PlayerDEBuffs_X,WLHUD_SAVE.Global_Y + WLHUD_SAVE.PlayerDEBuffs_Y)
				-- WLHUD_PLAYER.Cast_Anchor:SetAnchor(TOPLEFT, GuiRoot, TOPLEFT, WLHUD_SAVE.Global_X + WLHUD_SAVE.PlayerCast_Anchor_X,WLHUD_SAVE.Global_Y + WLHUD_SAVE.PlayerCast_Anchor_Y)

				WLHUD_TARGET.Anchor:SetAnchor(TOPLEFT, GuiRoot, TOPLEFT, WLHUD_SAVE.Global_X + WLHUD_SAVE.Target_Anchor_X,WLHUD_SAVE.Global_Y + WLHUD_SAVE.Target_Anchor_Y)
				WLHUD_TARGET.HP_Anchor:SetAnchor(TOPLEFT, GuiRoot, TOPLEFT, WLHUD_SAVE.Global_X + WLHUD_SAVE.TargetHP_Anchor_X,WLHUD_SAVE.Global_Y + WLHUD_SAVE.TargetHP_Anchor_Y)
				-- WLHUD_TARGET.Buff_MW:SetAnchor(TOPLEFT,GuiRoot,TOPLEFT, WLHUD_SAVE.Global_X + WLHUD_SAVE.TargetBuffs_X,WLHUD_SAVE.Global_Y + WLHUD_SAVE.TargetBuffs_Y)
				-- WLHUD_TARGET.DeBuff_MW:SetAnchor(TOPLEFT,GuiRoot,TOPLEFT, WLHUD_SAVE.Global_X + WLHUD_SAVE.TargetDEBuffs_X,WLHUD_SAVE.Global_Y + WLHUD_SAVE.TargetDEBuffs_Y)
				-- WLHUD_T_PreviewBuff_MW:SetAnchor(TOPLEFT,GuiRoot,TOPLEFT, WLHUD_SAVE.Global_X + WLHUD_SAVE.TargetBuffs_X,WLHUD_SAVE.Global_Y + WLHUD_SAVE.TargetBuffs_Y)
				-- WLHUD_T_PreviewDEBuff_MW:SetAnchor(TOPLEFT,GuiRoot,TOPLEFT, WLHUD_SAVE.Global_X + WLHUD_SAVE.TargetDEBuffs_X,WLHUD_SAVE.Global_Y + WLHUD_SAVE.TargetDEBuffs_Y)

				-- WLHUD_TARGET_T.Anchor:SetAnchor(TOPLEFT,GuiRoot,TOPLEFT, WLHUD_SAVE.Global_X + WLHUD_SAVE.TargetTarget_Anchor_X,WLHUD_SAVE.Global_Y + WLHUD_SAVE.TargetTarget_Anchor_Y)
			end)

	LAM:AddSlider(WLHUD_Menu, "WLHUD_GLOBAL_Y", WLHUD_GLOBAL_Y_Opt, WLHUD_GLOBAL_Y_Opt_LBL, -100, 100, 1,
			function() return WLHUD_SAVE.Global_Y end,
			function(value)
				WLHUD_SAVE.Global_Y = value

				WLHUD_MESSAGE:SetAnchor(TOPLEFT, GuiRoot, TOPLEFT, WLHUD_SAVE.Global_X + WLHUD_SAVE.SharedArea_X,WLHUD_SAVE.Global_Y + WLHUD_SAVE.SharedArea_Y)
				WLHUD_PLAYER.HP_Anchor:SetAnchor(TOPLEFT, GuiRoot, TOPLEFT, WLHUD_SAVE.Global_X + WLHUD_SAVE.PlayerHP_Anchor_X,WLHUD_SAVE.Global_Y + WLHUD_SAVE.PlayerHP_Anchor_Y)
				WLHUD_PLAYER_MP_Anchor:SetAnchor(TOPLEFT, GuiRoot, TOPLEFT, WLHUD_SAVE.Global_X + WLHUD_SAVE.PlayerMP_Anchor_X,WLHUD_SAVE.Global_Y + WLHUD_SAVE.PlayerMP_Anchor_Y)
				WLHUD_PLAYER.SP_Anchor:SetAnchor(TOPLEFT, GuiRoot, TOPLEFT, WLHUD_SAVE.Global_X + WLHUD_SAVE.PlayerSP_Anchor_X,WLHUD_SAVE.Global_Y + WLHUD_SAVE.PlayerSP_Anchor_Y)
				-- WLHUD_PLAYER.Buff_MW:SetAnchor(TOPLEFT,GuiRoot,TOPLEFT, WLHUD_SAVE.Global_X + WLHUD_SAVE.PlayerBuffs_X,WLHUD_SAVE.Global_Y + WLHUD_SAVE.PlayerBuffs_Y)
				-- WLHUD_PLAYER.DeBuff_MW:SetAnchor(TOPLEFT,GuiRoot,TOPLEFT, WLHUD_SAVE.Global_X + WLHUD_SAVE.PlayerDEBuffs_X,WLHUD_SAVE.Global_Y + WLHUD_SAVE.PlayerDEBuffs_Y)
				-- WLHUD_PreviewBuff_MW:SetAnchor(TOPLEFT,GuiRoot,TOPLEFT, WLHUD_SAVE.Global_X + WLHUD_SAVE.PlayerBuffs_X,WLHUD_SAVE.Global_Y + WLHUD_SAVE.PlayerBuffs_Y)
				-- WLHUD_PreviewDEBuff_MW:SetAnchor(TOPLEFT,GuiRoot,TOPLEFT, WLHUD_SAVE.Global_X + WLHUD_SAVE.PlayerDEBuffs_X,WLHUD_SAVE.Global_Y + WLHUD_SAVE.PlayerDEBuffs_Y)
				-- WLHUD_PLAYER.Cast_Anchor:SetAnchor(TOPLEFT, GuiRoot, TOPLEFT, WLHUD_SAVE.Global_X + WLHUD_SAVE.PlayerCast_Anchor_X,WLHUD_SAVE.Global_Y + WLHUD_SAVE.PlayerCast_Anchor_Y)

				WLHUD_TARGET.Anchor:SetAnchor(TOPLEFT, GuiRoot, TOPLEFT, WLHUD_SAVE.Global_X + WLHUD_SAVE.Target_Anchor_X,WLHUD_SAVE.Global_Y + WLHUD_SAVE.Target_Anchor_Y)
				WLHUD_TARGET.HP_Anchor:SetAnchor(TOPLEFT, GuiRoot, TOPLEFT, WLHUD_SAVE.Global_X + WLHUD_SAVE.TargetHP_Anchor_X,WLHUD_SAVE.Global_Y + WLHUD_SAVE.TargetHP_Anchor_Y)
				-- WLHUD_TARGET.Buff_MW:SetAnchor(TOPLEFT,GuiRoot,TOPLEFT, WLHUD_SAVE.Global_X + WLHUD_SAVE.TargetBuffs_X,WLHUD_SAVE.Global_Y + WLHUD_SAVE.TargetBuffs_Y)
				-- WLHUD_TARGET.DeBuff_MW:SetAnchor(TOPLEFT,GuiRoot,TOPLEFT, WLHUD_SAVE.Global_X + WLHUD_SAVE.TargetDEBuffs_X,WLHUD_SAVE.Global_Y + WLHUD_SAVE.TargetDEBuffs_Y)
				-- WLHUD_T_PreviewBuff_MW:SetAnchor(TOPLEFT,GuiRoot,TOPLEFT, WLHUD_SAVE.Global_X + WLHUD_SAVE.TargetBuffs_X,WLHUD_SAVE.Global_Y + WLHUD_SAVE.TargetBuffs_Y)
				-- WLHUD_T_PreviewDEBuff_MW:SetAnchor(TOPLEFT,GuiRoot,TOPLEFT, WLHUD_SAVE.Global_X + WLHUD_SAVE.TargetDEBuffs_X,WLHUD_SAVE.Global_Y + WLHUD_SAVE.TargetDEBuffs_Y)

				-- WLHUD_TARGET_T.Anchor:SetAnchor(TOPLEFT,GuiRoot,TOPLEFT, WLHUD_SAVE.Global_X + WLHUD_SAVE.TargetTarget_Anchor_X,WLHUD_SAVE.Global_Y + WLHUD_SAVE.TargetTarget_Anchor_Y)
			end)
end