local LAM = LibStub("LibAddonMenu-1.0")
local BarDir = {"Left to Right", "Right to Left"}

function WLHUD_Menu_Player()
	LAM:AddHeader(WLHUD_Menu, "WLHUD_Menu_Header_Player", "|cF0C300"..WLHUD_Header_PlayerOpt)

	--[[#############################################################################################################]]--
	--[[ MAIN ]]--
	--[[#############################################################################################################]]--
	LAM:AddSlider(WLHUD_Menu, "WLHUD_PlayerScale", WLHUD_PlayerSacle_Opt, WLHUD_PlayerSacle_Opt_LBL, 50, 100, 1,
		function() return WLHUD_SAVE.Player_Scale * 100 end,
		function(value)
			WLHUD_SAVE.Player_Scale = value / 100
			WLHUD_PLAYER.Anchor:SetScale(WLHUD_SAVE.Player_Scale)
			WLHUD_PLAYER.Anchor:SetHidden(false)
		end)

	LAM:AddSlider(WLHUD_Menu, "WLHUD_PLAYER.FadeOut", WLHUD_PLAYER.FadeOut_Opt, WLHUD_PLAYER.FadeOut_Opt_LBL, 0, 100, 1,
		function() return WLHUD_SAVE.Player_FadeOut * 100 end,
		function(value)
			WLHUD_SAVE.Player_FadeOut = value / 100

			WLHUD_PLAYER.HPB:SetAlpha(WLHUD_SAVE.Player_FadeOut)
			WLHUD_PLAYER.HPB:SetHidden(false)
			WLHUD_PLAYER.MPB:SetAlpha(WLHUD_SAVE.Player_FadeOut)
			WLHUD_PLAYER.MPB:SetHidden(false)
			WLHUD_PLAYER.SPB:SetAlpha(WLHUD_SAVE.Player_FadeOut)
			WLHUD_PLAYER.SPB:SetHidden(false)
		end)

	LAM:AddCheckbox(WLHUD_Menu, "Enable_P_StickyBars", "Sticky Bars", "ressource bars will move together",
		function() return WLHUD_SAVE.Enable_P_Sticky end, 
		function(val)
			WLHUD_SAVE.Enable_P_Sticky = val
			if (WLHUD_SAVE.Enable_P_Sticky == true) then
				WLHUD_PLAYER.MP_Anchor:SetAnchor(TOPLET, WLHUD_PLAYER.HP_Anchor, TOPLEFT, 0,30)
				WLHUD_PLAYER.SP_Anchor:SetAnchor(TOPLET, WLHUD_PLAYER.MP_Anchor, TOPLEFT, 0,30)
				WLHUD_PLAYER.Horse_Anchor:SetAnchor(TOPLET, WLHUD_PLAYER.SP_Anchor, TOPLEFT, -25,30)
			else
				WLHUD_PLAYER.MP_Anchor:SetAnchor(TOPLEFT, GuiRoot, TOPLEFT, WLHUD_SAVE.Global_X + WLHUD_SAVE.PlayerMP_Anchor_X,WLHUD_SAVE.Global_Y + WLHUD_SAVE.PlayerMP_Anchor_Y)
				WLHUD_PLAYER.SP_Anchor:SetAnchor(TOPLEFT, GuiRoot, TOPLEFT, WLHUD_SAVE.Global_X + WLHUD_SAVE.PlayerSP_Anchor_X,WLHUD_SAVE.Global_Y + WLHUD_SAVE.PlayerSP_Anchor_Y)
				WLHUD_PLAYER.Horse_Anchor:SetAnchor(TOPLEFT, GuiRoot, TOPLEFT, WLHUD_SAVE.Global_X + WLHUD_SAVE.Horse_Anchor_X,WLHUD_SAVE.Global_Y + WLHUD_SAVE.Horse_Anchor_Y)
			end
		end)

	--[[#############################################################################################################]]--
	--[[ MAXSTATS ]]--
	--[[#############################################################################################################]]--
	LAM:AddCheckbox(WLHUD_Menu, "Show_Player_MaxStats", WLHUD_PLAYER.MaxStats, WLHUD_PLAYER.MaxStats_LBL,
		function() return WLHUD_SAVE.Player_MaxStat end, 
		function(val)
			WLHUD_SAVE.Player_MaxStat = val
			WLHUD_PLAYER:Update()
		end)

	--[[#############################################################################################################]]--
	--[[ HP ]]--
	--[[#############################################################################################################]]--
	LAM:AddHeader(WLHUD_Menu, "WLHUD_Menu_Header_HP", "|cF0C300"..WLHUD_Header_HPOpt)

	LAM:AddCheckbox(WLHUD_Menu, "Enable_PlayerHP_Texture", "Enable Overlay Texture", "Enable Overlay Texture",
		function() return WLHUD_SAVE.PlayerHP_Texture end, 
		function(val)
			WLHUD_SAVE.PlayerHP_Texture = val
			WLHUD_PLAYER.HPB_Tex:SetHidden(not WLHUD_SAVE.PlayerHP_Texture)
		end)

	LAM:AddCheckbox(WLHUD_Menu, "WLHUD_PLAYER.HP_Alert", WLHUD_PLAYER.HP_AlertOpt, WLHUD_PLAYER.HP_AlertOpt_LBL,
		function() return WLHUD_SAVE.Player_HP_Alert end, 
		function(val)
			WLHUD_SAVE.Player_HP_Alert = val
			if (WLHUD_SAVE.Player_HP_Alert == false) and (WLHUD_ANIM_LOADED == true) then
				WLHUD_timelineLHP:Stop()
			elseif (WLHUD_SAVE.Player_HP_Alert == true) and (WLHUD_ANIM_LOADED == true) then
				WLHUD_timelineLHP:PlayFromStart()
			elseif (WLHUD_SAVE.Player_HP_Alert == true) and (WLHUD_ANIM_LOADED == false) then
				WLHUD_LoadWLHUD_animations()
			end
		end)	

	LAM:AddCheckbox(WLHUD_Menu, "Enable_Player_HP_Text", Enable_Player_HP_TextOpt, Enable_Player_HP_TextOpt_LBL,
		function() return WLHUD_SAVE.Player_HP_Enable end, 
		function(val)
			WLHUD_SAVE.Player_HP_Enable = val
			WLHUD_PLAYER.HPB_BG:SetHidden(not WLHUD_SAVE.Player_HP_Enable)
			WLHUD_PLAYER.HPBT:SetHidden(not WLHUD_SAVE.Player_HP_Enable)
		end)

	LAM:AddCheckbox(WLHUD_Menu, "Player_HP_InBar", Player_HP_TextOpt, Player_HP_TextOpt_LBL,
		function() return WLHUD_SAVE.Player_HP_InBar end, 
		function(val)
			WLHUD_SAVE.Player_HP_InBar = val
			WLHUD_PLAYER:Update()
		end)

	LAM:AddSlider(WLHUD_Menu, "WLHUD_PLAYER.HP_Tresh", WLHUD_PLAYER.HP_TreshOpt, WLHUD_PLAYER.HP_TreshOpt_LBL, 5, 60, 1,
		function() return WLHUD_SAVE.Player_HP_Tresh end,
		function(value)
			WLHUD_SAVE.Player_HP_Tresh = value
		end)

	LAM:AddSlider(WLHUD_Menu, "WLHUD_PlayerHPBar_Width", WLHUD_PlayerHPBar_Width_Opt, WLHUD_PlayerHPBar_Width_Opt_LBL, 250, 450, 1,
		function() return WLHUD_SAVE.Player_HPBar_Width end,
		function(value)
			WLHUD_SAVE.Player_HPBar_Width = value
			WLHUD_PLAYER.HPPerc:SetAnchor(LEFT, WLHUD_PLAYER.HP_Anchor, LEFT, (WLHUD_SAVE.Player_HPBar_Width / 450) * WLHUD_SAVE.Player_HPPerc_X + 152,0)
			WLHUD_PLAYER.HPB_Tex:SetWidth(WLHUD_SAVE.Player_HPBar_Width)
			WLHUD_PLAYER.HPB_BG:SetWidth(WLHUD_SAVE.Player_HPBar_Width + 140)
			WLHUD_PLAYER.HPB_TexBG:SetWidth(WLHUD_SAVE.Player_HPBar_Width )
			WLHUD_PLAYER.HPB:SetWidth(WLHUD_SAVE.Player_HPBar_Width)
			WLHUD_PLAYER.Anchor:SetHidden(false)
		end)

	LAM:AddSlider(WLHUD_Menu, "WLHUD_PlayerHPBar_Height", WLHUD_PlayerHPBar_Height_Opt, WLHUD_PlayerHPBar_Height_Opt_LBL, -5, 20, 1,
		function() return WLHUD_SAVE.PlayerHP_Height end,
		function(value)
			WLHUD_SAVE.PlayerHP_Height = value
			WLHUD_PLAYER.HPB_Tex:SetDimensions(WLHUD_SAVE.Player_HPBar_Width,26 + WLHUD_SAVE.PlayerHP_Height)
			WLHUD_PLAYER.HPB_TexBG:SetDimensions(WLHUD_SAVE.Player_HPBar_Width,27 + WLHUD_SAVE.PlayerHP_Height)
			WLHUD_PLAYER.HPB:SetDimensions(WLHUD_SAVE.Player_HPBar_Width,20 + WLHUD_SAVE.PlayerHP_Height)
			WLHUD_PLAYER.Anchor:SetHidden(false)
		end)

	LAM:AddCheckbox(WLHUD_Menu, "Enable_Player_HP_Perc", WLHUD_PLAYER.HPPercOpt, WLHUD_PLAYER.HPPercOpt_LBL,
		function() return WLHUD_SAVE.Enable_Player_HP_Perc end, 
		function(val)
			WLHUD_SAVE.Enable_Player_HP_Perc = val 
			WLHUD_PLAYER.HPPerc:SetHidden(not WLHUD_SAVE.Enable_Player_HP_Perc)
		end)

	LAM:AddSlider(WLHUD_Menu, "WLHUD_PlayerHPPerc_X", WLHUD_Move_HPPerc_Opt, WLHUD_PlayerHPPerc_Opt_LBL, -250, 455, 5,
		function() return WLHUD_SAVE.Player_HPPerc_X end,
		function(value)
			WLHUD_SAVE.Player_HPPerc_X = value
			WLHUD_PLAYER.HPPerc:SetAnchor(LEFT, WLHUD_PLAYER.HP_Anchor, LEFT, (WLHUD_SAVE.Player_HPBar_Width / 450) * WLHUD_SAVE.Player_HPPerc_X + 152,0)
			WLHUD_PLAYER.Anchor:SetHidden(false)
		end)

	--[[#############################################################################################################]]--
	--[[ MP ]]--
	--[[#############################################################################################################]]--
	LAM:AddHeader(WLHUD_Menu, "WLHUD_Menu_Header_MP", "|cF0C300"..WLHUD_Header_MPOpt)

	LAM:AddCheckbox(WLHUD_Menu, "Enable_PlayerMP_Texture", "Enable Overlay Texture", "Enable Overlay Texture",
		function() return WLHUD_SAVE.PlayerMP_Texture end,
		function(val)
			WLHUD_SAVE.PlayerMP_Texture = val
			WLHUD_PLAYER.MPB_Tex:SetHidden(not WLHUD_SAVE.PlayerMP_Texture)
		end)

	-- LAM:AddDropdown(WLHUD_Menu, "Drop_MPBarDir", "Bar Direction", "", BarDir,
	-- 	function() return WLHUD_SAVE.MPBarDir end, 
	-- 	function(val)
	-- 		WLHUD_SAVE.MPBarDir = val

	-- 		if (WLHUD_SAVE.MPBarDir == "Left to Right") then
	-- 			WLHUD_PLAYER.MPB:SetAnchor(RIGHT, WLHUD_PLAYER_MP_Anchor, RIGHT, 152 + WLHUD_SAVE.Player_MPBar_Width,0)
	-- 		else
	-- 			WLHUD_PLAYER.MPB:SetAnchor(LEFT, WLHUD_PLAYER_MP_Anchor, LEFT, 152,0)
	-- 		end
	-- 	end)

	LAM:AddCheckbox(WLHUD_Menu, "WLHUD_PLAYER_MP_Alert", WLHUD_PLAYER_MP_AlertOpt, WLHUD_PLAYER_MP_AlertOpt_LBL,
		function() return WLHUD_SAVE.Player_MP_Alert end, 
		function(val)
			WLHUD_SAVE.Player_MP_Alert = val
			if (WLHUD_SAVE.Player_MP_Alert == false) and (WLHUD_ANIM_LOADED == true) then
				WLHUD_timelineLMP:Stop()
			elseif (WLHUD_SAVE.Player_MP_Alert == true) and (WLHUD_ANIM_LOADED == true) then
				WLHUD_timelineLMP:PlayFromStart()
			elseif (WLHUD_SAVE.Player_MP_Alert == true) and (WLHUD_ANIM_LOADED == false) then
				WLHUD_LoadWLHUD_animations()
			end
		end)

	LAM:AddCheckbox(WLHUD_Menu, "Enable_Player_MP_Text", Enable_Player_MP_TextOpt, Enable_Player_MP_TextOpt_LBL,
		function() return WLHUD_SAVE.Player_MP_Enable end, 
		function(val)
			WLHUD_SAVE.Player_MP_Enable = val
			WLHUD_PLAYER.MPB_BG:SetHidden(not WLHUD_SAVE.Player_MP_Enable)
			WLHUD_PLAYER.MPBT:SetHidden(not WLHUD_SAVE.Player_MP_Enable)
		end)

	LAM:AddCheckbox(WLHUD_Menu, "Player_MP_InBar", Player_MP_TextOpt, Player_MP_TextOpt_LBL,
		function() return WLHUD_SAVE.Player_MP_InBar end, 
		function(val)
			WLHUD_SAVE.Player_MP_InBar = val
			WLHUD_PLAYER:Update()
		end)

	LAM:AddSlider(WLHUD_Menu, "WLHUD_PLAYER_MP_Tresh", WLHUD_PLAYER_MP_TreshOpt, WLHUD_PLAYER_MP_TreshOpt_LBL, 5, 60, 1,
		function() return WLHUD_SAVE.Player_MP_Tresh end,
		function(value)
			WLHUD_SAVE.Player_MP_Tresh = value
		end)

	LAM:AddSlider(WLHUD_Menu, "WLHUD_PlayerMPBar_Width", WLHUD_PlayerMPBar_Width_Opt, WLHUD_PlayerMPBar_Width_Opt_LBL, 250, 450, 1,
		function() return WLHUD_SAVE.Player_MPBar_Width end,
		function(value)
			WLHUD_SAVE.Player_MPBar_Width = value
			WLHUD_PLAYER.MPPerc:SetAnchor(LEFT, WLHUD_PLAYER_MP_Anchor, LEFT, (WLHUD_SAVE.Player_MPBar_Width / 450) * WLHUD_SAVE.Player_MPPerc_X + 152,0)
			WLHUD_PLAYER.MPB_Tex:SetWidth(WLHUD_SAVE.Player_MPBar_Width)
			WLHUD_PLAYER.MPB_TexBG:SetWidth(WLHUD_SAVE.Player_MPBar_Width)
			WLHUD_PLAYER.MPB_BG:SetWidth(WLHUD_SAVE.Player_MPBar_Width + 140)
			WLHUD_PLAYER.MPB:SetWidth(WLHUD_SAVE.Player_MPBar_Width)
			WLHUD_PLAYER.Anchor:SetHidden(false)
		end)

	LAM:AddSlider(WLHUD_Menu, "WLHUD_PlayerMPBar_Height", WLHUD_PlayerMPBar_Height_Opt, WLHUD_PlayerMPBar_Height_Opt_LBL, -5, 20, 1,
		function() return WLHUD_SAVE.PlayerMP_Height end,
		function(value)
			WLHUD_SAVE.PlayerMP_Height = value
			WLHUD_PLAYER.MPB_Tex:SetDimensions(WLHUD_SAVE.Player_MPBar_Width,26 + WLHUD_SAVE.PlayerMP_Height)
			WLHUD_PLAYER.MPB_TexBG:SetDimensions(WLHUD_SAVE.Player_MPBar_Width,27 + WLHUD_SAVE.PlayerMP_Height)
			WLHUD_PLAYER.MPB:SetDimensions(WLHUD_SAVE.Player_MPBar_Width,20 + WLHUD_SAVE.PlayerMP_Height)
			WLHUD_PLAYER.Anchor:SetHidden(false)
		end)

	LAM:AddCheckbox(WLHUD_Menu, "Enable_Player_MP_Perc", WLHUD_PLAYER.MPPercOpt, WLHUD_PLAYER.MPPercOpt_LBL,
		function() return WLHUD_SAVE.Enable_Player_MP_Perc end, 
		function(val)
			WLHUD_SAVE.Enable_Player_MP_Perc = val 
			WLHUD_PLAYER.MPPerc:SetHidden(not WLHUD_SAVE.Enable_Player_MP_Perc)
		end)

	LAM:AddSlider(WLHUD_Menu, "WLHUD_PlayerMPPerc_X", WLHUD_Move_MPPerc_Opt, WLHUD_PlayerMPPerc_Opt_LBL, -250, 455, 5,
		function() return WLHUD_SAVE.Player_MPPerc_X end,
		function(value)
			WLHUD_SAVE.Player_MPPerc_X = value
			WLHUD_PLAYER.MPPerc:SetAnchor(LEFT, WLHUD_PLAYER_MP_Anchor, LEFT, (WLHUD_SAVE.Player_MPBar_Width / 450) * WLHUD_SAVE.Player_MPPerc_X + 152,0)
			WLHUD_PLAYER.Anchor:SetHidden(false)
		end)

	--[[#############################################################################################################]]--
	--[[ SP ]]--
	--[[#############################################################################################################]]--
	LAM:AddHeader(WLHUD_Menu, "WLHUD_Menu_Header_SP", "|cF0C300"..WLHUD_Header_SPOpt)

	LAM:AddCheckbox(WLHUD_Menu, "Enable_PlayerSP_Texture", "Enable Overlay Texture", "Enable Overlay Texture",
		function() return WLHUD_SAVE.PlayerSP_Texture end, 
		function(val)
			WLHUD_SAVE.PlayerSP_Texture = val
			WLHUD_PLAYER.SPB_Tex:SetHidden(not WLHUD_SAVE.PlayerSP_Texture)
		end)

	LAM:AddCheckbox(WLHUD_Menu, "WLHUD_PLAYER_SP_Alert", WLHUD_PLAYER_SP_AlertOpt, WLHUD_PLAYER_SP_AlertOpt_LBL,
		function() return WLHUD_SAVE.Player_SP_Alert end, 
		function(val)
			WLHUD_SAVE.Player_SP_Alert = val
			if (WLHUD_SAVE.Player_SP_Alert == false) and (WLHUD_ANIM_LOADED == true) then
				WLHUD_timelineLSP:Stop()
			elseif (WLHUD_SAVE.Player_SP_Alert == true) and (WLHUD_ANIM_LOADED == true) then
				WLHUD_timelineLSP:PlayFromStart()
			elseif (WLHUD_SAVE.Player_SP_Alert == true) and (WLHUD_ANIM_LOADED == false) then
				WLHUD_LoadWLHUD_animations()
			end
		end)

	LAM:AddCheckbox(WLHUD_Menu, "Enable_Player_SP_Text", Enable_Player_SP_TextOpt, Enable_Player_SP_TextOpt_LBL,
		function() return WLHUD_SAVE.Player_SP_Enable end, 
		function(val)
			WLHUD_SAVE.Player_SP_Enable = val
			WLHUD_PLAYER.SPB_BG:SetHidden(not WLHUD_SAVE.Player_SP_Enable)
			WLHUD_PLAYER.SPBT:SetHidden(not WLHUD_SAVE.Player_SP_Enable)
		end)

	LAM:AddCheckbox(WLHUD_Menu, "Player_SP_InBar", Player_SP_TextOpt, Player_SP_TextOpt_LBL,
		function() return WLHUD_SAVE.Player_SP_InBar end, 
		function(val)
			WLHUD_SAVE.Player_SP_InBar = val
			WLHUD_PLAYER:Update()
		end)

	LAM:AddSlider(WLHUD_Menu, "WLHUD_PLAYER_SP_Tresh", WLHUD_PLAYER_SP_TreshOpt, WLHUD_PLAYER_SP_TreshOpt_LBL, 5, 60, 1,
		function() return WLHUD_SAVE.Player_SP_Tresh end,
		function(value)
			WLHUD_SAVE.Player_SP_Tresh = value
		end)

	LAM:AddSlider(WLHUD_Menu, "WLHUD_PlayerSPBar_Width", WLHUD_PlayerSPBar_Width_Opt, WLHUD_PlayerSPBar_Width_Opt_LBL, 250, 450, 1,
		function() return WLHUD_SAVE.Player_SPBar_Width end,
		function(value)
			WLHUD_SAVE.Player_SPBar_Width = value
			WLHUD_PLAYER.SPPerc:SetAnchor(LEFT, WLHUD_PLAYER.SP_Anchor, LEFT, (WLHUD_SAVE.Player_SPBar_Width / 450) * WLHUD_SAVE.Player_SPPerc_X + 152,0)
			WLHUD_PLAYER.SPB_Tex:SetWidth(WLHUD_SAVE.Player_SPBar_Width)
			WLHUD_PLAYER.SPB_TexBG:SetWidth(WLHUD_SAVE.Player_SPBar_Width)
			WLHUD_PLAYER.SPB_BG:SetWidth(WLHUD_SAVE.Player_SPBar_Width + 140)
			WLHUD_PLAYER.SPB:SetWidth(WLHUD_SAVE.Player_SPBar_Width)
			WLHUD_PLAYER.Anchor:SetHidden(false)
		end)

	LAM:AddSlider(WLHUD_Menu, "WLHUD_PlayerSPBar_Height", WLHUD_PlayerSPBar_Height_Opt, WLHUD_PlayerSPBar_Height_Opt_LBL, -5, 20, 1,
		function() return WLHUD_SAVE.PlayerSP_Height end,
		function(value)
			WLHUD_SAVE.PlayerSP_Height = value
			WLHUD_PLAYER.SPB_Tex:SetDimensions(WLHUD_SAVE.Player_SPBar_Width,26 + WLHUD_SAVE.PlayerSP_Height)
			WLHUD_PLAYER.SPB_TexBG:SetDimensions(WLHUD_SAVE.Player_SPBar_Width,27 + WLHUD_SAVE.PlayerSP_Height)
			WLHUD_PLAYER.SPB:SetDimensions(WLHUD_SAVE.Player_SPBar_Width,20 + WLHUD_SAVE.PlayerSP_Height)
			WLHUD_PLAYER.Anchor:SetHidden(false)
		end)

	LAM:AddCheckbox(WLHUD_Menu, "Enable_Player_SP_Perc", WLHUD_PLAYER.SPPercOpt, WLHUD_PLAYER.SPPercOpt_LBL,
		function() return WLHUD_SAVE.Enable_Player_SP_Perc end, 
		function(val)
			WLHUD_SAVE.Enable_Player_SP_Perc = val 
			WLHUD_PLAYER.SPPerc:SetHidden(not WLHUD_SAVE.Enable_Player_SP_Perc)
		end)

	LAM:AddSlider(WLHUD_Menu, "WLHUD_PlayerSPPerc_X", WLHUD_Move_SPPerc_Opt, WLHUD_PlayerSPPerc_Opt_LBL, -250, 455, 5,
		function() return WLHUD_SAVE.Player_SPPerc_X end,
		function(value)
			WLHUD_SAVE.Player_SPPerc_X = value
			WLHUD_PLAYER.SPPerc:SetAnchor(LEFT, WLHUD_PLAYER.SP_Anchor, LEFT, (WLHUD_SAVE.Player_MPBar_Width / 450) * WLHUD_SAVE.Player_SPPerc_X + 152,0)
			WLHUD_PLAYER.Anchor:SetHidden(false)
		end)

	--[[#############################################################################################################]]--
	--[[ CAST ]]--
	--[[#############################################################################################################]]--
	-- LAM:AddHeader(WLHUD_Menu, "WLHUD_Menu_Header_Cast", "|cF0C300"..WLHUD_Header_CastOpt)

	-- LAM:AddCheckbox(WLHUD_Menu, "Enable_Player_CastBar", WLHUD_PLAYER.CastOpt, WLHUD_PLAYER.CastOpt_LBL,
	-- 	function() return WLHUD_SAVE.Enable_Player_CastBar end, 
	-- 	function(val)
	-- 		WLHUD_SAVE.Enable_Player_CastBar = val
	-- 		WLHUD_PlayerCastAnchor:SetHidden(not WLHUD_SAVE.Enable_Player_CastBar)
	-- 	end)

	-- LAM:AddColorPicker(WLHUD_Menu, "WLHUD_PCast_ColorS", WLHUD_PCast_ColorSOpt, WLHUD_PCast_ColorSOpt_LBL,
	-- 	function() return WLHUD_SAVE.PCastS_R, WLHUD_SAVE.PCastS_G, WLHUD_SAVE.PCastS_B end,
	-- 	function(r,g,b,a)
	-- 		WLHUD_SAVE.PCastS_R = r
	-- 		WLHUD_SAVE.PCastS_G = g
	-- 		WLHUD_SAVE.PCastS_B = b
	-- 		WLHUD_PlayerCast_Bar:SetGradientColors(WLHUD_SAVE.PCastE_R, WLHUD_SAVE.PCastE_G, WLHUD_SAVE.PCastE_B,1 ,WLHUD_SAVE.PCastS_R, WLHUD_SAVE.PCastS_G, WLHUD_SAVE.PCastS_B,1)
	-- 	end)

	-- LAM:AddColorPicker(WLHUD_Menu, "WLHUD_PCast_ColorE", WLHUD_PCast_ColorEOpt, WLHUD_PCast_ColorEOpt_LBL,
	-- 	function() return WLHUD_SAVE.PCastE_R, WLHUD_SAVE.PCastE_G, WLHUD_SAVE.PCastE_B end,
	-- 	function(r,g,b,a)
	-- 		WLHUD_SAVE.PCastE_R = r
	-- 		WLHUD_SAVE.PCastE_G = g
	-- 		WLHUD_SAVE.PCastE_B = b
	-- 		WLHUD_PlayerCast_Bar:SetGradientColors(WLHUD_SAVE.PCastE_R, WLHUD_SAVE.PCastE_G, WLHUD_SAVE.PCastE_B,1 ,WLHUD_SAVE.PCastS_R, WLHUD_SAVE.PCastS_G, WLHUD_SAVE.PCastS_B,1)
	-- 	end)

	-- LAM:AddSlider(WLHUD_Menu, "WLHUD_PlayerCastBar_Width", WLHUD_PlayerCastBar_Width_Opt, WLHUD_PlayerCastBar_Width_Opt_LBL, 250, 450, 1,
	-- 	function() return WLHUD_SAVE.Player_CatBar_Width end,
	-- 	function(value)
	-- 		WLHUD_SAVE.Player_CatBar_Width = value
	-- 		WLHUD_PLAYER.Cast_BG:SetWidth(WLHUD_SAVE.Player_CatBar_Width)
	-- 		WLHUD_PLAYER.Anchor:SetHidden(false)
	-- 	end)

	--[[#############################################################################################################]]--
	--[[ BUFFS ]]--
	--[[#############################################################################################################]]--
	-- LAM:AddHeader(WLHUD_Menu, "WLHUD_Menu_Header_Buffs", "|cF0C300"..WLHUD_Header_BuffsOpt)

	-- LAM:AddCheckbox(WLHUD_Menu, "Enable_Player_Buffs", WLHUD_PLAYER.BuffsOpt, WLHUD_PLAYER.BuffsOpt_LBL,
	-- 	function() return WLHUD_SAVE.Enable_Player_Buffs end, 
	-- 	function(val)
	-- 		WLHUD_SAVE.Enable_Player_Buffs = val
	-- 		WLHUD_PLAYER.Buff_MW:SetHidden(not WLHUD_SAVE.Enable_Player_Buffs)
	-- 		WLHUD_PreviewBuff_MW:SetHidden(not WLHUD_SAVE.Enable_Player_Buffs)
	-- 	end)

	-- LAM:AddColorPicker(WLHUD_Menu, "WLHUD_PBuffs_Color_BG", WLHUD_PBuff_BG_ColorOpt, WLHUD_PBuff_BG_ColorOpt,
	-- 	function() return WLHUD_SAVE.PBuff_BG_R, WLHUD_SAVE.PBuff_BG_G, WLHUD_SAVE.PBuff_BG_B end,
	-- 	function(r,g,b,a)
	-- 		WLHUD_SAVE.PBuff_BG_R = r
	-- 		WLHUD_SAVE.PBuff_BG_G = g
	-- 		WLHUD_SAVE.PBuff_BG_B = b
	-- 		WLHUD_PBuff_PreviewBG:SetEdgeColor(WLHUD_SAVE.PBuff_BG_R, WLHUD_SAVE.PBuff_BG_G, WLHUD_SAVE.PBuff_BG_B, 1)
	-- 	end)

	-- LAM:AddCheckbox(WLHUD_Menu, "Enable_Player_Buffs_Tm", WLHUD_PLAYER.BuffsOpt_Tm, WLHUD_PLAYER.BuffsOpt_Tm_LBL,
	-- 	function() return WLHUD_SAVE.Enable_Player_Buffs_Tm end, 
	-- 	function(val)
	-- 		WLHUD_SAVE.Enable_Player_Buffs_Tm = val
	-- 		WLHUD_PBuff_Preview_LBL:SetHidden(not WLHUD_SAVE.Enable_Player_Buffs_Tm)
	-- 	end)

	-- LAM:AddColorPicker(WLHUD_Menu, "WLHUD_PBuffs_Color", WLHUD_PBuff_ColorOpt, WLHUD_PBuff_ColorOpt,
	-- 	function() return WLHUD_SAVE.PBuff_R, WLHUD_SAVE.PBuff_G, WLHUD_SAVE.PBuff_B end,
	-- 	function(r,g,b,a)
	-- 		WLHUD_SAVE.PBuff_R = r
	-- 		WLHUD_SAVE.PBuff_G = g
	-- 		WLHUD_SAVE.PBuff_B = b
	-- 		WLHUD_PBuff_Preview_LBL:SetColor(WLHUD_SAVE.PBuff_R, WLHUD_SAVE.PBuff_G, WLHUD_SAVE.PBuff_B, 1)
	-- 	end)

	-- LAM:AddCheckbox(WLHUD_Menu, "Enable_Player_Buffs_longTerm", WLHUD_PLAYER.BuffsLongTerm, WLHUD_PLAYER.BuffsLongTerm_LBL,
	-- 	function() return WLHUD_SAVE.Player_PermaBuffs end, 
	-- 	function(val)
	-- 		WLHUD_SAVE.Player_PermaBuffs = val
	-- 	end)

	-- LAM:AddSlider(WLHUD_Menu, "WLHUD_PBuff_Scale", WLHUD_PBuff_Scale_Opt, WLHUD_PBuff_Scale_Opt_LBL, 50, 100, 1,
	-- 	function() return WLHUD_SAVE.PBuff_Scale * 100 end,
	-- 	function(value)
	-- 		WLHUD_SAVE.PBuff_Scale = value / 100
	-- 		WLHUD_PLAYER.Buff_MW:SetScale(WLHUD_SAVE.PBuff_Scale)
	-- 		WLHUD_PreviewBuff_MW:SetScale(WLHUD_SAVE.PBuff_Scale)
	-- 	end)
		
	-- LAM:AddCheckbox(WLHUD_Menu, "Enable_Player_DEBuffs", WLHUD_PLAYER.DEBuffsOpt, WLHUD_PLAYER.DEBuffsOpt_LBL,
	-- 	function() return WLHUD_SAVE.Enable_Player_DEBuffs end, 
	-- 	function(val)
	-- 		WLHUD_SAVE.Enable_Player_DEBuffs = val 
	-- 		WLHUD_PLAYER.DeBuff_MW:SetHidden(not WLHUD_SAVE.Enable_Player_DEBuffs)
	-- 		WLHUD_PreviewDEBuff_MW:SetHidden(not WLHUD_SAVE.Enable_Player_DEBuffs)
	-- 	end)

	-- LAM:AddColorPicker(WLHUD_Menu, "WLHUD_PDEBuffs_Color_BG", WLHUD_PDEBuff_BG_ColorOpt, WLHUD_PDEBuff_BG_ColorOpt,
	-- 	function() return WLHUD_SAVE.PDEBuff_BG_R, WLHUD_SAVE.PDEBuff_BG_G, WLHUD_SAVE.PDEBuff_BG_B end,
	-- 	function(r,g,b,a)
	-- 		WLHUD_SAVE.PDEBuff_BG_R = r
	-- 		WLHUD_SAVE.PDEBuff_BG_G = g
	-- 		WLHUD_SAVE.PDEBuff_BG_B = b
	-- 		WLHUD_PDEBuff_PreviewBG:SetEdgeColor(WLHUD_SAVE.PDEBuff_BG_R, WLHUD_SAVE.PDEBuff_BG_G, WLHUD_SAVE.PDEBuff_BG_B, 1)
	-- 	end)

	-- LAM:AddCheckbox(WLHUD_Menu, "Enable_Player_DEBuffs_Tm", WLHUD_PLAYER.DEBuffsOpt_Tm, WLHUD_PLAYER.DEBuffsOpt_Tm_LBL,
	-- 	function() return WLHUD_SAVE.Enable_Player_DEBuffs_Tm end, 
	-- 	function(val)
	-- 		WLHUD_SAVE.Enable_Player_DEBuffs_Tm = val
	-- 		WLHUD_PDEBuff_Preview_LBL:SetHidden(not WLHUD_SAVE.Enable_Player_DEBuffs_Tm)
	-- 	end)

	-- LAM:AddColorPicker(WLHUD_Menu, "WLHUD_PDEBuffs_Color", WLHUD_PDEBuff_ColorOpt, WLHUD_PDEBuff_ColorOpt_LBL,
	-- 	function() return WLHUD_SAVE.PDEBuff_R, WLHUD_SAVE.PDEBuff_G, WLHUD_SAVE.PDEBuff_B end,
	-- 	function(r,g,b,a)
	-- 		WLHUD_SAVE.PDEBuff_R = r
	-- 		WLHUD_SAVE.PDEBuff_G = g
	-- 		WLHUD_SAVE.PDEBuff_B = b
	-- 		WLHUD_PDEBuff_Preview_LBL:SetColor(WLHUD_SAVE.PDEBuff_R, WLHUD_SAVE.PDEBuff_G, WLHUD_SAVE.PDEBuff_B, 1)
	-- 	end)

	-- LAM:AddSlider(WLHUD_Menu, "WLHUD_PDEBuff_Scale", WLHUD_PDEBuff_Scale_Opt, WLHUD_PDEBuff_Scale_Opt_LBL, 50, 100, 1,
	-- 	function() return WLHUD_SAVE.PDEBuff_Scale * 100 end,
	-- 	function(value)
	-- 		WLHUD_SAVE.PDEBuff_Scale = value / 100
	-- 		WLHUD_PLAYER.DeBuff_MW:SetScale(WLHUD_SAVE.PDEBuff_Scale)
	-- 		WLHUD_PreviewDEBuff_MW:SetScale(WLHUD_SAVE.PDEBuff_Scale)
	-- 	end)
	
end --WLHUD_Menu_Player()