local WLHUD_BufferTable = {}

--[[------------------------------
 * Buffer
 ]]-------------------------------
local function WLHUD_BufferReached(key, buffer)
	if not key then return end
	local ct, buffer = GetFrameTimeMilliseconds(), buffer or 3
	if not WLHUD_BufferTable[key] then WLHUD_BufferTable[key] = ct end
	if (ct - WLHUD_BufferTable[key]) >= buffer
	then WLHUD_BufferTable[key] = ct; return true;
	else return false; end
end

local WLH_ROUND = function(num, idp)
  local mult = 10^(idp or 0)
  return math.floor(num * mult + 0.5) / mult
end

local function WLHUD_UPDATE_Distance()
	local ishidden = ZO_ReticleContainer:IsHidden()
	local inmousemode = IsGameCameraUIModeActive()
	local shouldHide, distance = true, nil
	local doesexist = DoesUnitExist("reticleover")

	-- ratio taill ZO_WorldMapContainer:GetDimensions() Cyrodiil

	-- if not ishidden and not inmousemode and doesexist then
	-- 	-- local combattarget = (GetUnitNameHighlightedByReticle() ~= "" and IsGameCameraUnitHighlightedAttackable()) 
	-- 	-- if combattarget then
	-- 		-- shouldHide = false
	-- 		local mapWidth, mapHeight = ZO_WorldMapContainer:GetDimensions()
	-- 		local playerX, playerY, playerH = GetMapPlayerPosition("player")
	-- 		local targetX, targetY, targetH = GetMapPlayerPosition("reticleover")
	-- 		local nplayerX = (((playerX / mapWidth) * 100) + 0) * 10000
	-- 		local nplayerY = (((playerY / mapHeight) * 100) + 0) * 10000
	-- 		local ntargetX = (((targetX / mapWidth) * 100) + 0) * 10000
	-- 		local ntargetY = (((targetY / mapHeight) * 100) + 0) * 10000
	-- 		local cyromult = 8.1760751694390089745940967694364
	-- 		local mapratio = mapWidth / 810

	-- 		d(mapWidth)

	-- 		distance = (math.sqrt(math.pow((nplayerX - ntargetX),2) + math.pow((nplayerY - ntargetY),2)) * cyromult) * mapratio
	-- 	-- end
	-- end
	
	-- wykkydsFramework.RangeFrame( shouldHide, distance )

	if not ishidden and not inmousemode and doesexist then
		-- local combattarget = (GetUnitNameHighlightedByReticle() ~= "" and IsGameCameraUnitHighlightedAttackable()) 
		-- if combattarget then
			-- shouldHide = false
			local mapWidth, mapHeight, mapDiff, contentType = GetMapNumTiles(), GetMapType(), GetMapContentType()
			local playerX, playerY, playerH = GetMapPlayerPosition("player")
			local targetX, targetY, targetH = GetMapPlayerPosition("reticleover")
			if mapDiff == 1 then mapDiff = 3 else mapDiff = 1 end
			if contentType == 2 then mapDiff = 7 end
			local dist = math.sqrt(math.pow(((playerX - targetX)/mapWidth)/mapDiff,2) + math.pow(((playerY - targetY)/mapHeight)/mapDiff,2))
			local pct = (dist*10000) * 1 --/ 32
			distance = WLH_ROUND(pct, 10)
			-- distance = pct
			-- d(distance)
		-- end
	end
	-- d(distance)
	-- WLHUD_TARGET.Distance:SetText(distance)
end

local function WLHUD_Refresh015() -- Refresh each 0.15 sec
	-- if not WLHUD_BufferReached("WLHUD_Refresh015", 150) then return end
	-- if (WLHUD_SAVE.Enable_Player_Buffs == true) then WLHUD_PLAYER:Update_Buffs() end
	-- if (WLHUD_SAVE.Enable_Player_Buffs == true) then WLHUD_PLAYER:Update_DeBuffs() end
	-- if (WLHUD_SAVE.Enable_Target_Buffs == true) then WLHUD_TARGET:Update_Buffs() end
	-- if (WLHUD_SAVE.Enable_Target_DEBuffs == true) then WLHUD_TARGET:Update_DeBuffs() end

	-- MOVE ZO_ FRAMES --
	ZO_Death:SetAnchor(CENTER, WLHUD_MESSAGE, CENTER, 0,0)
	ZO_PlayerToPlayerArea:ClearAnchors()
	ZO_PlayerToPlayerArea:SetAnchor(CENTER, WLHUD_MESSAGE, CENTER, 0,200)
	ZO_Ram:ClearAnchors()
	ZO_Ram:SetAnchor(CENTER, GuiRoot, CENTER, 0,200)
	ZO_Ram:SetScale(0.75)

	ZO_SynergyTopLevelContainer:ClearAnchors()
	ZO_SynergyTopLevelContainer:SetAnchor(CENTER, WLHUD_MESSAGE, CENTER, 0,0)

	if (not ZO_OptionsWindow:IsHidden()) then
		ZO_OptionsWindow:SetAnchor(TOPLEFT, GuiRoot, TOPLEFT, 245,-50)
		ZO_OptionsWindow:SetHeight(1000)
		ZO_OptionsWindowBGLeft:SetHeight(1000) 
		ZO_OptionsWindowBGLeftBGRight:SetHeight(1000)
	end

	if (WLHUD_SAVE.Enable_MemUsage == true) then
		local Garbage_Count = collectgarbage("count")
		local WLHUD_MemUsed = Garbage_Count / 1024
		WLHUD_MEM_USAGE.LBL:SetText( (WLHUD_MemUsed_Trad1.. string.format(": |c7FDD4C %.3f" , WLHUD_MemUsed) .. "|r "..WLHUD_MemUsed_Trad2) )
		WLHUD_MEM_USAGE.BG:SetHidden(false)
		WLHUD_MEM_USAGE.LBL:SetHidden(false)
	else
		WLHUD_MEM_USAGE.Anchor:SetHidden(true)
	end

	WLHUD_UPDATE_Distance()
end

local function WLHUD_Refresh02() -- Refresh each 0.2 sec
	-- if not WLHUD_BufferReached("WLHUD_Refresh02", 200) then return end

	local Fade_Player_HP_C, Fade_Player_HP_M = GetUnitPower("player", -2)

	if ( WLHUD_SAVE.Enable_Preview == false ) then
		if (Fade_Player_HP_C == Fade_Player_HP_M) then
			if (WLHUD_INCOMBAT == true) then
				-- WLHUD_PLAYER.Anchor:SetAlpha(1)
				WLHUD_PLAYER.HPB:SetAlpha(1)
				WLHUD_PLAYER.MPB:SetAlpha(1)
				WLHUD_PLAYER.SPB:SetAlpha(1)

				WLHUD_TARGET.HPB:SetAlpha(1)
			else
				-- WLHUD_PLAYER.Anchor:SetAlpha(WLHUD_SAVE.Player_FadeOut)
				WLHUD_PLAYER.HPB:SetAlpha(WLHUD_SAVE.Player_FadeOut)
				WLHUD_PLAYER.MPB:SetAlpha(WLHUD_SAVE.Player_FadeOut)
				WLHUD_PLAYER.SPB:SetAlpha(WLHUD_SAVE.Player_FadeOut)

				WLHUD_TARGET.HPB:SetAlpha(WLHUD_SAVE.Target_FadeOut)
			end
		else
			-- WLHUD_PLAYER.Anchor:SetAlpha(1)
			WLHUD_PLAYER.HPB:SetAlpha(1)
			WLHUD_PLAYER.MPB:SetAlpha(1)
			WLHUD_PLAYER.SPB:SetAlpha(1)

			-- WLHUD_TARGET.HPB:SetAlpha(1)
		end
	end

	-- d(WLHUD_TARGETNAME[GetUnitName("reticleover")])
	-- if (WLHUD_TARGETNAME[GetUnitName("reticleover")] ~= nil) then
	-- 	if (WLHUD_TARGETNAME[GetUnitName("reticleover")] == 1) then
	-- 		WLHUD_VISUALIZER["reticleover831"]:SetHidden(false)
	-- 		WLHUD_TIMELINE["reticleover831"]:PlayFromStart()
	-- 		d("WLHUD_TargetChanged")
	-- 	end
	-- end
end

-- local function WLHUD_Refresh002()

	-- if not WLHUD_BufferReached("WLHUD_Refresh002", 20) then return end

	-- if (WLHUD_SETTINGS == 0) and ( WLHUD_SAVE.Enable_Preview == false ) then
		-- if (WLHUD_SAVE.Enable_Player_CastBar == true) then WLHUD_UpdatePlayerCastBar() end

		-- if (WLHUD_SAVE.Enable_Target == true) then
		-- 	if (WLHUD_SAVE.Enable_Target_CastBar == true) then WLHUD_UpdateTargetCastBar() end
		-- end

		-- if (IsUnitInCombat("reticleover") ~= true) then
		-- 	-- WLHUD_TARGET_T.Anchor:SetHidden(true)
		-- else
		-- 	if (WLHUD_SAVE.Enable_Target_T == true) then
		-- 		-- WLHUD_TARGET_T.Anchor:SetHidden(false)
		-- 		if (WLHUD_SAVE.Enable_Target_T_CastBar == true) then WLHUD_UpdateTargetTargetCastBar() end
		-- 	end
		-- end
	-- end
-- end

function WLHUD_Refresh001() -- Refresh each 0.01 sec
	if (WLHUD_FIRSTLOAD == false) then
		return
	else

		-- if not WLHUD_BufferReached("WLHUD_OnUpdate", 10) then return end

		ZO_PlayerAttribute:SetHidden(true)

		ZO_TargetUnitFramereticleover:SetHidden( not WLHUD_SAVE.Def_ZOS_Target )

		
		if (WLHUD_SAVE.Enable_Preview == true) then WLHUD_Preview() end
	end
end

function WLHUD_Loaded()
	
	WLHUD_PLAYER:Update()

	-- local WLHUD_Loop002 = WLHUD_ACE:ScheduleRepeatingTimer(function() WLHUD_Refresh002() end, 0.02)
	local WLHUD_Loop02  = WLHUD_ACE:ScheduleRepeatingTimer(function() WLHUD_Refresh02() end, 0.2)
	local WLHUD_Loop015  = WLHUD_ACE:ScheduleRepeatingTimer(function() WLHUD_Refresh015() end, 0.15)
	-- local WLHUD_Loop01  = WLHUD_ACE:ScheduleRepeatingTimer(function() WLHUD_Refresh001() end, 0.001)
end