local function WLHUD_Chain( object )
	
	-- Setup the metatable
	local T = {}
	setmetatable( T, { __index = function( self, func )
		
		-- Know when to stop chaining
		if func == "__END" then	return object end
		
		-- Otherwise, add the method to the parent object
		return function( self, ... )
			assert( object[func], func .. " missing in object" )
			object[func]( object, ... )
			return self
		end
	end })
	
	-- Return the metatable
	return T
end


function WLHUD_Visualizer_CreateAnim()
	WLHUD_VISUALIZER["MW"] = WLHUD_Chain(WINDOW_MANAGER:CreateTopLevelWindow("WLHUD_VISUALIZER_MW"))
		:SetScale(WLHUD_SAVE.Player_Scale)
		-- :SetHidden(true)
	.__END

	--[[PLAYER]]-- ==========================================================================================
	-- HoT -- player381
	WLHUD_VISUALIZER["player381"] = WLHUD_Chain(WINDOW_MANAGER:CreateControl("WLHUD_VISUALIZER_player381", WLHUD_PLAYER.HPB, CT_TEXTURE ))
		:SetDimensions(100,64)
		:SetTexture("WarLegendHUD/img/visual/p_HoT.dds")
		:SetDrawLayer(3)
		:SetAnchor(LEFT, WLHUD_PLAYER.HPB, LEFT,0,0)
		:SetHidden(true)
	.__END

	WLHUD_ANIM["player381"], WLHUD_TIMELINE["player381"] = CreateSimpleAnimation(ANIMATION_TEXTURESLIDE, WLHUD_VISUALIZER["player381"])
	WLHUD_ANIM["player381"]:SetSlideDistances(-1,0)
	WLHUD_ANIM["player381"]:SetDuration(1000)
	WLHUD_TIMELINE["player381"]:SetPlaybackType(ANIMATION_PLAYBACK_LOOP, LOOP_INDEFINITELY)
	
	-- Regen Stamina-- player3303
	WLHUD_VISUALIZER["player3303"] = WLHUD_Chain(WINDOW_MANAGER:CreateControl("WLHUD_VISUALIZER_player3303", WLHUD_PLAYER.SPB, CT_TEXTURE ))
		:SetDimensions(100,64)
		:SetTexture("WarLegendHUD/img/visual/p_HoT.dds")
		:SetDrawLayer(3)
		:SetAnchor(LEFT, WLHUD_PLAYER.SPB, LEFT,0,0)
		:SetHidden(true)
	.__END

	WLHUD_ANIM["player3303"], WLHUD_TIMELINE["player3303"] = CreateSimpleAnimation(ANIMATION_TEXTURESLIDE, WLHUD_VISUALIZER["player3303"])
	WLHUD_ANIM["player3303"]:SetSlideDistances(-1,0)
	WLHUD_ANIM["player3303"]:SetDuration(1000)
	WLHUD_TIMELINE["player3303"]:SetPlaybackType(ANIMATION_PLAYBACK_LOOP, LOOP_INDEFINITELY)

	-- Boost Resist -- player731
	WLHUD_VISUALIZER["player731"] = WLHUD_Chain(WINDOW_MANAGER:CreateControl("WLHUD_VISUALIZER_player731", WLHUD_PLAYER.HPB, CT_TEXTURE ))
		:SetDimensions(35 + WLHUD_SAVE.Player_HPBar_Width,63 + WLHUD_SAVE.PlayerHP_Height)
		:SetTexture("WarLegendHUD/img/visual/p_increased_resist.dds")
		:SetAnchor(LEFT, WLHUD_PLAYER.HPB, LEFT,-10,0)
		:SetColor(255/255,215/255,0,1)
		:SetDrawLayer(3)
		:SetHidden(true)
	.__END

	WLHUD_ANIM["player731"], WLHUD_TIMELINE["player731"] = CreateSimpleAnimation(ANIMATION_SCALE, WLHUD_VISUALIZER["player731"])
	WLHUD_ANIM["player731"]:SetScaleValues(0.95,1.0)
	WLHUD_ANIM["player731"]:SetDuration(500)
	WLHUD_TIMELINE["player731"]:SetPlaybackType(ANIMATION_PLAYBACK_PING_PONG, LOOP_INDEFINITELY)

	-- DoT -- player481
	WLHUD_VISUALIZER["player481"] = WLHUD_Chain(WINDOW_MANAGER:CreateControl("WLHUD_VISUALIZER_player481", WLHUD_PLAYER.HPB, CT_TEXTURE ))
		:SetDimensions(128,32)
		:SetTexture("WarLegendHUD/img/visual/p_dot.dds")
		:SetDrawLayer(3)
		:SetAnchor(RIGHT, WLHUD_PLAYER.HPB_Tex, RIGHT,0,0)
		:SetColor(247/255, 255/255, 0, 1)
		:SetHidden(true)
	.__END

	WLHUD_ANIM["player481"], WLHUD_TIMELINE["player481"] = CreateSimpleAnimation(ANIMATION_TEXTURESLIDE, WLHUD_VISUALIZER["player481"])
	WLHUD_ANIM["player481"]:SetSlideDistances(1,0)
	WLHUD_ANIM["player481"]:SetDuration(1000)
	WLHUD_TIMELINE["player481"]:SetPlaybackType(ANIMATION_PLAYBACK_LOOP, LOOP_INDEFINITELY)

	-- Boost Weapon -- player7351
	WLHUD_VISUALIZER["player7351"] = WLHUD_Chain(WINDOW_MANAGER:CreateControl("WLHUD_VISUALIZER_player7351", WLHUD_VISUALIZER["MW"], CT_TEXTURE ))
		:SetDimensions(ZO_ActionBar1:GetWidth() * 2.5,ZO_ActionBar1:GetHeight() * 4)
		:SetTexture("EsoUI/Art/UnitAttributeVisualizer/increasedPower_animatedHalo_32fr.dds")
		:SetAnchor(CENTER, ZO_ActionBar1, CENTER,0,0)
		:SetHidden(true)
	.__END

	WLHUD_ANIM["player7351"], WLHUD_TIMELINE["player7351"] = CreateSimpleAnimation(ANIMATION_TEXTURE, WLHUD_VISUALIZER["player7351"])
	WLHUD_ANIM["player7351"]:SetImageData(4,8)
	WLHUD_ANIM["player7351"]:SetFramerate(32)
	WLHUD_ANIM["player7351"]:SetDuration(1000)
	WLHUD_TIMELINE["player7351"]:SetPlaybackType(ANIMATION_PLAYBACK_PING_PONG, LOOP_INDEFINITELY)

	-- Decrease Armor -- player831
	WLHUD_VISUALIZER["player831"] = WLHUD_Chain(WINDOW_MANAGER:CreateControl("WLHUD_VISUALIZER_player831", WLHUD_PLAYER.HPB, CT_TEXTURE ))
		:SetDimensions(20 + WLHUD_SAVE.Player_HPBar_Width,30 + WLHUD_SAVE.PlayerHP_Height)
		:SetTexture("WarLegendHUD/img/visual/decrease_armor.dds")
		:SetAnchor(CENTER, WLHUD_PLAYER.HPB_Tex, CENTER, 0,0)
		:SetDrawLayer(3)
		:SetHidden(true)
	.__END

	WLHUD_ANIM["player831"], WLHUD_TIMELINE["player831"] = CreateSimpleAnimation(ANIMATION_SCALE, WLHUD_VISUALIZER["player831"])
	WLHUD_ANIM["player831"]:SetScaleValues(0.95,1.0)
	WLHUD_ANIM["player831"]:SetDuration(125)
	WLHUD_TIMELINE["player831"]:SetPlaybackType(ANIMATION_PLAYBACK_PING_PONG, LOOP_INDEFINITELY)

	--[[TARGET]]-- ==========================================================================================
	-- HoT -- reticleover381
	WLHUD_VISUALIZER["reticleover381"] = WLHUD_Chain(WINDOW_MANAGER:CreateControl("WLHUD_VISUALIZER_reticleover381", WLHUD_TARGET.HPB, CT_TEXTURE ))
		:SetDimensions(100,64)
		:SetTexture("WarLegendHUD/img/visual/p_HoT.dds")
		:SetDrawLayer(3)
		:SetAnchor(LEFT, WLHUD_TARGET.HPB, LEFT,0,0)
		:SetHidden(true)
	.__END

	WLHUD_ANIM["reticleover381"], WLHUD_TIMELINE["reticleover381"] = CreateSimpleAnimation(ANIMATION_TEXTURESLIDE, WLHUD_VISUALIZER["reticleover381"])
	WLHUD_ANIM["reticleover381"]:SetSlideDistances(-1,0)
	WLHUD_ANIM["reticleover381"]:SetDuration(1000)
	WLHUD_TIMELINE["reticleover381"]:SetPlaybackType(ANIMATION_PLAYBACK_LOOP, LOOP_INDEFINITELY)
	
	-- Regen Stamina-- reticleover3303
	-- WLHUD_VISUALIZER["reticleover3303"] = WLHUD_Chain(WINDOW_MANAGER:CreateControl("WLHUD_VISUALIZER_reticleover3303", WLHUD_TARGET.SPB, CT_TEXTURE ))
	-- 	:SetDimensions(100,64)
	-- 	:SetTexture("WarLegendHUD/img/visual/p_HoT.dds")
	-- 	:SetDrawLayer(3)
	-- 	:SetAnchor(LEFT, WLHUD_TARGET.SPB, LEFT,0,0)
	-- 	:SetHidden(true)
	-- .__END

	-- WLHUD_ANIM["reticleover3303"], WLHUD_TIMELINE["reticleover3303"] = CreateSimpleAnimation(ANIMATION_TEXTURESLIDE, WLHUD_VISUALIZER["reticleover3303"])
	-- WLHUD_ANIM["reticleover3303"]:SetSlideDistances(-1,0)
	-- WLHUD_ANIM["reticleover3303"]:SetDuration(1000)
	-- WLHUD_TIMELINE["reticleover3303"]:SetPlaybackType(ANIMATION_PLAYBACK_LOOP, LOOP_INDEFINITELY)

	-- Boost Resist -- reticleover731
	WLHUD_VISUALIZER["reticleover731"] = WLHUD_Chain(WINDOW_MANAGER:CreateControl("WLHUD_VISUALIZER_reticleover731", WLHUD_TARGET.HPB, CT_TEXTURE ))
		:SetDimensions(35 + WLHUD_SAVE.Player_HPBar_Width,63 + WLHUD_SAVE.PlayerHP_Height)
		:SetTexture("WarLegendHUD/img/visual/p_increased_resist.dds")
		:SetAnchor(LEFT, WLHUD_TARGET.HPB, LEFT,-10,0)
		:SetColor(255/255,215/255,0,1)
		:SetDrawLayer(3)
		:SetHidden(true)
	.__END

	WLHUD_ANIM["reticleover731"], WLHUD_TIMELINE["reticleover731"] = CreateSimpleAnimation(ANIMATION_SCALE, WLHUD_VISUALIZER["reticleover731"])
	WLHUD_ANIM["reticleover731"]:SetScaleValues(0.95,1.0)
	WLHUD_ANIM["reticleover731"]:SetDuration(500)
	WLHUD_TIMELINE["reticleover731"]:SetPlaybackType(ANIMATION_PLAYBACK_PING_PONG, LOOP_INDEFINITELY)

	-- DoT -- reticleover481
	WLHUD_VISUALIZER["reticleover481"] = WLHUD_Chain(WINDOW_MANAGER:CreateControl("WLHUD_VISUALIZER_reticleover481", WLHUD_TARGET.HPB, CT_TEXTURE ))
		:SetDimensions(128,32)
		:SetTexture("WarLegendHUD/img/visual/p_dot.dds")
		:SetDrawLayer(3)
		:SetAnchor(RIGHT, WLHUD_TARGET.HPB_Tex, RIGHT,0,0)
		:SetColor(247/255, 255/255, 0, 1)
		:SetHidden(true)
	.__END

	WLHUD_ANIM["reticleover481"], WLHUD_TIMELINE["reticleover481"] = CreateSimpleAnimation(ANIMATION_TEXTURESLIDE, WLHUD_VISUALIZER["reticleover481"])
	WLHUD_ANIM["reticleover481"]:SetSlideDistances(1,0)
	WLHUD_ANIM["reticleover481"]:SetDuration(1000)
	WLHUD_TIMELINE["reticleover481"]:SetPlaybackType(ANIMATION_PLAYBACK_LOOP, LOOP_INDEFINITELY)

	-- Decrease Armor -- reticleover831
	WLHUD_VISUALIZER["reticleover831"] = WLHUD_Chain(WINDOW_MANAGER:CreateControl("WLHUD_VISUALIZER_reticleover831", WLHUD_TARGET.Anchor, CT_TEXTURE ))
		:SetDimensions(20 + WLHUD_SAVE.Target_HPBar_Width,30 + WLHUD_SAVE.TargetHP_Height)
		:SetTexture("WarLegendHUD/img/visual/decrease_armor.dds")
		:SetAnchor(CENTER, WLHUD_TARGET.HPB_Tex, CENTER, 0,0)
		:SetDrawLayer(3)
		:SetHidden(true)
	.__END

	WLHUD_ANIM["reticleover831"], WLHUD_TIMELINE["reticleover831"] = CreateSimpleAnimation(ANIMATION_SCALE, WLHUD_VISUALIZER["reticleover831"])
	WLHUD_ANIM["reticleover831"]:SetScaleValues(0.95,1.0)
	WLHUD_ANIM["reticleover831"]:SetDuration(125)
	WLHUD_TIMELINE["reticleover831"]:SetPlaybackType(ANIMATION_PLAYBACK_PING_PONG, LOOP_INDEFINITELY)
end --WLHUD_Visualizer_CreateAnim()

function WLHUD_Visualizer_Added( eventCode, unitTag, unitAttributeVisual, statType, attributeType, powerType, value, maxValue )
	if (unitTag == "player") then		
		if (WLHUD_VISUALIZER[unitTag..unitAttributeVisual..statType..attributeType] ~= nil) then --[[TESTCODE]]--
			WLHUD_VISUALIZER[unitTag..unitAttributeVisual..statType..attributeType]:SetHidden(false)
			WLHUD_TIMELINE[unitTag..unitAttributeVisual..statType..attributeType]:PlayFromStart()
		else
			-- d("|cB22222Visualizer: |cFFFFFF"..unitTag..unitAttributeVisual..statType..attributeType)
		end
	elseif (unitTag == "reticleover") then
		if (unitAttributeVisual == 8) and (statType == 3) and (attributeType == 1) then --831
			WLHUD_VISUALIZER[unitTag..unitAttributeVisual..statType..attributeType]:SetHidden(false)
			WLHUD_TIMELINE[unitTag..unitAttributeVisual..statType..attributeType]:PlayFromStart()
			WLHUD_TARGETNAME[GetUnitName("reticleover")] = true
			WLHUD_GAMETIME = GetGameTimeMilliseconds()
		else
			if (WLHUD_VISUALIZER[unitTag..unitAttributeVisual..statType..attributeType] ~= nil) then --[[TESTCODE]]--
				WLHUD_VISUALIZER[unitTag..unitAttributeVisual..statType..attributeType]:SetHidden(false)
				WLHUD_TIMELINE[unitTag..unitAttributeVisual..statType..attributeType]:PlayFromStart()
			else
				-- d("|cB22222Visualizer: |cFFFFFF"..unitTag..unitAttributeVisual..statType..attributeType)
			end
		end
	else
		-- d("|cB22222Visualizer: |cFFFFFF"..unitTag..unitAttributeVisual..statType..attributeType)
	end
end --WLHUD_Visualizer_Added()

function WLHUD_Visualizer_Removed( eventCode, unitTag, unitAttributeVisual, statType, attributeType, powerType, value, maxValue )
	if (unitTag == "player") then
		if (WLHUD_VISUALIZER[unitTag..unitAttributeVisual..statType..attributeType] ~= nil) then --[[TESTCODE]]--
			WLHUD_VISUALIZER[unitTag..unitAttributeVisual..statType..attributeType]:SetHidden(true)
			WLHUD_TIMELINE[unitTag..unitAttributeVisual..statType..attributeType]:Stop()
		else
			-- d("|cB22222Visualizer: |cFFFFFF"..unitTag..unitAttributeVisual..statType..attributeType)
		end

	elseif (unitTag == "reticleover") then
		if (unitAttributeVisual == 8) and (statType == 3) and (attributeType == 1) then --831
			WLHUD_VISUALIZER[unitTag..unitAttributeVisual..statType..attributeType]:SetHidden(true)
			WLHUD_TIMELINE[unitTag..unitAttributeVisual..statType..attributeType]:Stop()
			WLHUD_TARGETNAME[GetUnitName("reticleover")] = false
		else
			if (WLHUD_VISUALIZER[unitTag..unitAttributeVisual..statType..attributeType] ~= nil) then --[[TESTCODE]]--
				WLHUD_VISUALIZER[unitTag..unitAttributeVisual..statType..attributeType]:SetHidden(true)
				WLHUD_TIMELINE[unitTag..unitAttributeVisual..statType..attributeType]:Stop()
			else
				-- d("|cB22222Visualizer: |cFFFFFF"..unitTag..unitAttributeVisual..statType..attributeType)
			end
		end
	else
		-- d("|cB22222Visualizer: |cFFFFFF"..unitTag..unitAttributeVisual..statType..attributeType)
	end
end --WLHUD_Visualizer_Removed()